/*
        LG Game 1   - Ett spel av Legion Sommaren 2000


        Filformat fr level (.lev) filer:

        Beskrivning           | Offset | Bytes | vrigt
        ----------------------|--------| ------| ------
        Version och identitet | 0x0000 | 6     | Ska vara "LGL100"
        Namn p banan         | 0x0006 | 20    |
        Ban identitet         | 0x001A | 1     |
        Lngd i pixlar        | 0x001B | 2     | Hg byte frst
        Hjd i pixlar         | 0x001D | 2     | Hg byte frst
        Antal block i banan   | 0x001F | 2     | Hg byte frst
        Antal fiender i banan | 0x0021 | 2     | Hg byte frst
        Antal saker i banan   | 0x0023 | 2     | Hg byte frst
        Spelarestart X        | 0x0025 | 2     | Hg byte frst
        Spelarestart Y        | 0x0027 | 2     | Hg byte frst
        Blocktyp              | 0x0029 | 1     |
        Blockposition X       | 0x002A | 2     | Hg byte frst
        Blockposition Y       | 0x002C | 2     | Hg byte frst
        Blockstopp 1 X        | 0x002E | 2     | Hg byte frst
        Blockstopp 1 Y        | 0x0020 | 2     | Hg byte frst
        Blockstopp 2 X        | 0x0032 | 2     | Hg byte frst
        Blockstopp 2 Y        | 0x0034 | 2     | Hg byte frst
        ...                   ...      ...     ...
        Fiendetyp             | ?      | 1     |
        Fiendeposition X      | ?      | 2     | Hg byte frst
        Fiendeposition Y      | ?      | 2     | Hg byte frst
        Fiendestopp 1 X       | ?      | 2     | Hg byte frst
        Fiendestopp 1 Y       | ?      | 2     | Hg byte frst
        Fiendestopp 2 X       | ?      | 2     | Hg byte frst
        Fiendestopp 2 Y       | ?      | 2     | Hg byte frst
        ...                   ...      ...     ...
        Saktyp                | ?      | 1     |
        Sakposition X         | ?      | 2     | Hg byte frst
        Sakposition Y         | ?      | 2     | Hg byte frst
        Sakstopp 1 X          | ?      | 2     | Hg byte frst
        Sakstopp 1 Y          | ?      | 2     | Hg byte frst
        Sakstopp 2 X          | ?      | 2     | Hg byte frst
        Sakstopp 2 Y          | ?      | 2     | Hg byte frst
        ...                   ...      ...     ...



        Jmna versionstal i den mittersta siffran r stabila
        Ojmna versionstal i den mittersta siffran r ostabila
        [*] = Fixad
        [+] = Nytt
        [-] = Borttaget
        [!] = Fel som ska fixas
        [/] = Inaktiverad
        [^] = Information

        Versionshistoria frn och med 2000-06-25 13:56

        V 0.6.7  2000-07-04 20:21
        -------------------------
         [^] DEBUG mode
         [^] Ingen bana medfljer
         [-] Man kan inte lngre g upp fr "backar", kommer frmodligen tillbaka i nsta version
         [*] Koden prioriterar att dda fienden istllet fr att ta skada
         [+] Gubben rr p fossingarna
         [*] Vrde fr banan i hjdled r tillagd, gamla banor kommer inte att fungera
         [*] Frflyttningsknapparna (s, d, f, e) i editorn fungerar nu p alla objekt
         [*] En bugg i deletefunktionen r fixad
         [!] Ingen bakgrund p det som r under 190 pixlar i Y led
         [!] Att man inte kan scrolla nr man placerar ut fiender
         [!] Fel om man bygger fr stora banor
         [!] Texturfel p dom lutande texturerna
        -------------------------

        V 0.6.6  2000-07-02 02:57
        -------------------------
         [^] DEBUG mode
         [*] Fel nr man ska ta bort block som ligger utanfr de
             frsta 320 pixlarna
         [+] Pongsiffror visar hur mnga pong man fr p varje sak eller fiende
         [!] Att man inte kan scrolla nr man placerar ut fiender
         [!] Eventuellt fel om man bygger fr stora banor
         [!] Texturfel p dom lutande texturerna
        -------------------------

        V 0.6.5  2000-07-01 01:12
        -------------------------
         [^] DEBUG mode
         [+] Delete funktion i editorn
         [+] Man kan lta fienderna g mellan tv valfria punkter
         [*] Omskrivet filformat fr .lev filer
         [*] Diverse funktioner i editorn
         [!] Eventuellt fel om man bygger fr stora banor
         [^] Gamla .lev filer kommer inte att fungera med denna version
        -------------------------

        V 0.6.3  2000-06-29 22:16
        -------------------------
         [^] DEBUG mode
         [!] Paletten p bakgrundsbilden (by bild)
         [*] Ljudeffektsbugen, nu ska det fungera p alla datorer
         [+] Felmeddelanden om MIDAS skulle misslyckas med ngot
         [+] man kan g ver en pixel hga kanter
         [+] Nya texturer och fiender
         [*] Fixat s att fienderna ochs byter hll (som spelaren)
         -------------------------

        V 0.6.2  2000-06-26 22:16
        -------------------------
         [^] DEBUG mode
         [!] Paletten p bakgrundsbilden
         [*] Hoppbugen fixad
         [*] Gubben hoppar hgre och finare
         [+] Nya texturer och fiender
         [^] Vissa texturer ligger med, men dom laddas inte
         [^] Innom kort kommer .lev filformatet att byggas ut
         [^] Editorn kommer f nya funktioner
         -------------------------


        V 0.6.1  2000-06-26 12:09
        -------------------------
         [^] DEBUG mode
         [^] Bakgrunden laddas, men ritas fr nrvarande inte ut
         [*] Fixat s att det inte hnger sig nr man ska skapa banor
         [!] Nr man hoppar s kan man fasna i luften
         [+] Debugtexter p design_new_level();
         [^] Innom kort kommer .lev filformatet att byggas ut
         [^] Editorn kommer f nya funktioner
         -------------------------

        V 0.6.0  2000-06-26 00:23
        -------------------------
         [^] DEBUG mode
         [^] Bakgrunden laddas, men ritas fr nrvarande inte ut
         [+] Ljudeffekter
         [+] Man kan dda fienderna
        -------------------------

        V 0.5.4  2000-06-25 22:41
        -------------------------
         [^] DEBUG mode
         [*] Fienderna rr sig lngsammare
         [+] Skada och ddsfunktion
         [+] Bakgrund
         [^] Bakgrunden laddas, men ritas fr nrvarande inte ut
        -------------------------

        V 0.5.1  2000-06-25 19:38
        -------------------------
         [^] DEBUG mode
         [*] Fler kommentarer
         [*] .lev filbeskrivning
         [+] Spelsync
         [-] Joystick/Joypad std
        -------------------------

        V 0.5.0  2000-06-25 13:56
        -------------------------
         [^] DEBUG mode
         [*] Musik
         [*] Bttre kommenterad kod
         [-] Spelsync
         [^] Denna version r endast till fr test av kompatiblitet
        -------------------------

*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <midasdll.h>
#include <allegro.h>


#define TEXTURECOUNT 13  // Antal texturer som ska laddas
#define ENEMYCOUNT 7    // Antal fiendetexturer som ska laddas
#define ITEMCOUNT 3     // Antal saktexturer som ska laddas
#define SNDSAMPLECOUNT 4  // Antal ljudeffekter som ska laddas
#define MENUTEXT "T <->  E <->  I <-> PS Delete Exit"  // Den text som visas i levelcreatorn
#define NOMUSIC FALSE  // Om TRUE s r musiken avstngd
#define GAMESPEED 120000  // Ju strre desto snabbare
#define NOSYNC FALSE  // Om TRUE s r synkroniseringen avstngd
#define DEBUG TRUE  // Visar informationstexter
#define PLAYERBLINK 200 // Antal blinkningar nr man tar skada
#define WALKDELAY 3  // Antal loopar innan fienderna fr lov att flytta p sig...
#define SAMPFREQ 22050 // Standard samplingsfrekvens p ljudeffekter
#define SFXVOL 64    // Standard volym p ljudeffekter
#define ITEMPYMAX 10  // Antal pixlar som pong siffran ska stiga p saker
#define ENEMYPYMAX 10  // Antal pixlar som pong siffran ska stiga p fiender
#define ITEMPYDEL 4   // Antal loopar innan texten stiger en pixel
#define ENEMYPYDEL 4   // Antal loopar innan texten stiger en pixel
#define FOTCHANGECOUNT 5  // Antal frames innan han byter fotsteg



struct TItemPos  // Sparar undan alla variabler som ett objekt kan tnkas behva
{
  int ident;
  int Visible;
  long x;
  long y;
  long Stop1x;
  long Stop1y;
  long Stop2x;
  long Stop2y;
  long StartX;
  long StartY;
  int Py;
  int PyDel;
  int xdec, xinc;
  int ydec, yinc;
  int Colll, Collr;
  int Dir;
  int fall;
  int WalkDelay;
} TItemPos;

struct TLevelMask     // Kollisionsmask fr banan
{
  int mask:4; // OBS! endast fyra bitar
};

typedef struct TLevelData  // Alla variabler som har med den aktulla banan att gra
{
  unsigned int Length;
  unsigned int Height;
  BITMAP *LevelBitmap;
  BITMAP *Background;
  BITMAP *LevelBackgr;
  PALETTE Pal;
  char Name[20];
  unsigned char ident;
  unsigned int BlockCount;
  unsigned int EnemyCount;
  unsigned int ItemCount;
  unsigned int xoff;
  unsigned int yoff;
  int xinc, xdec;
  int yinc, ydec;
  struct TItemPos *BlockPos;     // Allokeras dynamiskt vid inladdning av banan
  struct TItemPos *EnemyPos;     // -//-
  struct TItemPos *ItemPos;      // -//-
  struct TLevelMask *LevelMask;  // -//-
  int Scroll;
} TLevelData;


typedef struct TTexture     // Information om texturer
{
  BITMAP *Bitmap;
  unsigned int Width;
  unsigned int Height;
  PALETTE Pal;
} TTexture;

typedef struct TPlayerInfo  // Alla variabler som behvs fr att styra spelaren
{
  BITMAP *Bitmap1, *Bitmap2, *Bitmap3, *Bitmap4, *Bitmap5, *Bitmap6;
  unsigned int x;
  unsigned int y;
  unsigned int StartX;
  unsigned int StartY;
  int xdec, xinc;
  int xdecj, xincj;
  int jump, fall;
  unsigned int jumpx, jumpy;
  int Colll, Collr;
  PALETTE Pal;
  int Dir;
  unsigned long Score;
  int Blink, BlinkCount;
  int Health;
  int fot;
} TPlayerInfo;

typedef struct TEnemyInfo  // Alla variabler som behvs fr fiendetexturer
{
  BITMAP *Bitmap1, *Bitmap2;
  PALETTE Pal;
} TEnemyInfo;

typedef struct TItemInfo  // Alla variabler som behvs fr Saktexturer
{
  BITMAP *Bitmap1, *Bitmap2;
  PALETTE Pal;
} TItemInfo;

 typedef struct TSndSample  // Alla variabler som behvs fr Saktexturer
{
  MIDASsample Sample;
  MIDASsamplePlayHandle Handle;
} TSndSample;


int gKey=0, gFastKey=0;            // Innehller vilken knapp man tryckte p
int  gfxmode=GFX_TEXT, joyen=FALSE, mouseen=TRUE;
int SfxVol=SFXVOL;
TLevelData LevelData;
TTexture Texture[TEXTURECOUNT];
TPlayerInfo Player;
TEnemyInfo Enemy[ENEMYCOUNT];
TItemInfo Item[ITEMCOUNT];
int BlockTextureCount=TEXTURECOUNT, EnemyTextureCount=ENEMYCOUNT, ItemTextureCount=ITEMCOUNT;
TSndSample SndSample[SNDSAMPLECOUNT];
MIDASmodule testmod;
MIDASmodulePlayHandle playHandle;
BITMAP *Vir1;
DATAFILE *Dat;
FONT *Pfont;
DATAFILE *Datafile;
int LevelCount=0;
int FotChange=0;
struct TItemPos *TempPos;
int Refr=FALSE;
int Design=FALSE;
int JumpPathNum=0;   // JumpPath bestmmer hur spelaren ska hoppa
//int LastBlockIdent=1000, LastEnemyIdent=1000, LastItemIdent=1000;
int LastIdent=1000;
#define JUMPPATHCOUNT 60
int JumpPath[JUMPPATHCOUNT] =
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,1,1,1,1,0,1,1,1,1,1,1,1,1,0,1,1,0,1,0,1,1,0,1,1,0,1,0,0,1,0,0,1,0,1,0,0,1,0,0,0,1};

int equit(char *exitstr)  // Stnger ner programmet och visar ett felmeddelande
{
  if (gfxmode!=GFX_TEXT)
    set_gfx_mode(GFX_TEXT, 640, 480, 0, 0);
  printf("Error!\n  - %s\nSorry abaout that...",exitstr);
  if (Design)
    remove_mouse();
  if (joyen)
    remove_joystick();
  remove_keyboard();
  allegro_exit();
  exit(1);
  return 0;
}

int quit(char *exitstr)  // Stnger programmet och visar ett meddelande
{
  if (gfxmode!=GFX_TEXT)
    set_gfx_mode(GFX_TEXT, 640, 480, 0, 0);
  printf("%s",exitstr);
  if (joyen)
    remove_joystick();
  remove_keyboard();
  allegro_exit();
  exit(0);
  return 0;
}

void MIDASerror(void)
{
  int         error;
  if (gfxmode!=GFX_TEXT)
    set_gfx_mode(GFX_TEXT, 640, 480, 0, 0);
  error = MIDASgetLastError();
  printf("\nMIDAS error: %s\n", MIDASgetErrorMessage(error));
  if ( !MIDASclose() )
  {
    printf("\nBIG PANIC!! MIDASclose Failed: %s\nARGH!!!  I hate errors!", MIDASgetErrorMessage(
      MIDASgetLastError()));
  }
  if (joyen)
    remove_joystick();
  remove_keyboard();
  allegro_exit();
  exit(1);
}

void KeyRelease(int Key)    // Kallas vid keyboard interupt
{
  gFastKey=Key;
  if (Key & 0x80)
  {
    switch(Key & 127)   // Nr man slpper knappen
    {
      case  31 : Player.xdec=FALSE;
                 break;
      case  33 : Player.xinc=FALSE;
                 break;
      case  77 : if (Design)
                   LevelData.xinc=FALSE;
                 else
                 {
                   Player.xinc=FALSE;
                 }
                 break;
      case  75 : if (Design)
                   LevelData.xdec=FALSE;
                 else
                 {
                   Player.xdec=FALSE;
                 }
                 break;
      case  72 : if (Design)
                   LevelData.ydec=FALSE;
                 break;
      case  80 : if (Design)
                   LevelData.yinc=FALSE;
                 break;
    }
  }
  else
  {
    switch(Key & 127)    // Nr man trycker...
    {
      case  18 :  if ((!Player.fall) && (!Player.jump)/* && (!PreventExtraJump)*/)
                 {
                   if ((!NOMUSIC) && (!Design))
                     if ((SndSample[2].Handle=MIDASplaySample(SndSample[2].Sample, MIDAS_CHANNEL_AUTO, 0, SAMPFREQ, SfxVol, MIDAS_PAN_MIDDLE))==0)
                       MIDASerror();
                   Player.jump=TRUE;
                   Player.jumpx=Player.x;
                   Player.jumpy=Player.y;
                   JumpPathNum=0;
                 }
                 break;
      case  72 : if ((!Player.fall) && (!Player.jump)/* && (!PreventExtraJump)*/)
                 {
                   if ((!NOMUSIC) && (!Design))
                     if ((SndSample[2].Handle=MIDASplaySample(SndSample[2].Sample, MIDAS_CHANNEL_AUTO, 0, SAMPFREQ, SfxVol, MIDAS_PAN_MIDDLE))==0)
                       MIDASerror();
                   Player.jump=TRUE;
                   Player.jumpx=Player.x;
                   Player.jumpy=Player.y;
                   JumpPathNum=0;
                 }
                 if (Design)
                   LevelData.ydec=TRUE;
                 break;
      case  80 : if (Design)
                   LevelData.yinc=TRUE;
                 break;
      case  31 : Player.xdec=TRUE;
                 Player.Dir=1;
                 break;
      case  33 : Player.xinc=TRUE;
                 Player.Dir=0;
                 break;
      case  77:  if (Design)
                   LevelData.xinc=TRUE;
                 else
                 {
                   Player.xinc=TRUE;
                   Player.Dir=0;
                 }
                 break;
      case  75:  if (Design)
                   LevelData.xdec=TRUE;
                 else
                 {
                   Player.xdec=TRUE;
                   Player.Dir=1;
                 }
                 break;
    }
  }
}

unsigned short hi(unsigned int inpt)  // Returnerar den hga byten
{
  return ((inpt & 0xFF00) >> 8);
}

unsigned short lo(unsigned int inpt)  // Returnerar den lga byten
{
  return (inpt & 0x00FF);
}


int update_level()
{
  blit(LevelData.LevelBackgr, Vir1, LevelData.xoff, LevelData.yoff, 0, 10, 320, 190);
  masked_blit(LevelData.LevelBitmap, Vir1, LevelData.xoff, LevelData.yoff, 0, 10, 320, 190);
  hline(Vir1, 0, 9, 320, 100);
  text_mode(0);
  textprintf(Vir1, font, 0,0, 100, "%s  Score: %i  Health: %i", LevelData.Name, Player.Score, Player.Health);
 // textprintf(Vir1, font, 0,0,100, "Jump: %i", Player.jump);
 return 0;
}


int player_die()
{
  int y=0, a=0;
  if ((!Design))
  {
    if (!NOMUSIC)
      MIDASstopModule(playHandle);
  }
  y=Player.y;
  while ((y-30)<Player.y)
  {
    Player.y--;
    update_level();
    if (Player.Dir==0)
      draw_sprite(Vir1, Player.Bitmap1, Player.x, Player.y);
    if (Player.Dir==1)
      draw_sprite(Vir1, Player.Bitmap2, Player.x, Player.y);
    if (!NOSYNC)
      while (!Refr) {}
    blit(Vir1, screen, 0,0,0,0, 320,200);
  }
  while (Player.y<200)
  {
    Player.y++;
    update_level();
    if (Player.Dir==0)
      draw_sprite(Vir1, Player.Bitmap1, Player.x, Player.y);
    if (Player.Dir==1)
      draw_sprite(Vir1, Player.Bitmap2, Player.x, Player.y);
    if (!NOSYNC)
      while (!Refr) {}
    blit(Vir1, screen, 0,0,0,0, 320,200);
  }
  Player.x=Player.StartX;
  Player.y=Player.StartY;
  for (a=0;a<LevelData.EnemyCount;a++)
  {
    LevelData.EnemyPos[a].x=LevelData.EnemyPos[a].StartX;
    LevelData.EnemyPos[a].y=LevelData.EnemyPos[a].StartY;
    LevelData.EnemyPos[a].Visible=TRUE;
  }
  for (a=0;a<LevelData.ItemCount;a++)
  {
    LevelData.ItemPos[a].Visible=TRUE;
  }
  Player.Score=0;
  LevelData.xoff=0;
  Player.Health=3;
  Player.Blink=FALSE;
  Player.BlinkCount=0;
  clear(Vir1);
  clear(screen);
  //readkey();
  if ((!Design))
  {
    if ((!Design) && (!NOMUSIC))
      playHandle=MIDASplayModule(testmod, TRUE);
  }
  return 0;
}

int player_hurt()
{
  if (!NOMUSIC)
    SndSample[3].Handle=MIDASplaySample(SndSample[3].Sample, MIDAS_CHANNEL_AUTO, 0, 22050, SfxVol, MIDAS_PAN_MIDDLE);
  Player.Health--;
  if (Player.Health<1)
  {
    player_die();
  }
  Player.Blink=TRUE;
  Player.BlinkCount=PLAYERBLINK;
  return 0;
}


int update_items()
{
  int a;
  for (a=0;a<LevelData.ItemCount;a++)
  {
    if (LevelData.ItemPos[a].Visible)
    {
      draw_sprite(Vir1, Item[LevelData.ItemPos[a].ident].Bitmap1, LevelData.ItemPos[a].x-LevelData.xoff, LevelData.ItemPos[a].y+10-LevelData.yoff);
    }
    else
    {
      if (LevelData.ItemPos[a].Py<ITEMPYMAX)
      {
        text_mode(-1);
        textprintf(Vir1, Pfont, LevelData.ItemPos[a].x-LevelData.xoff, LevelData.ItemPos[a].y-LevelData.ItemPos[a].Py-LevelData.yoff, 125, "%i", (LevelData.ItemPos[a].ident+1)*25);
        LevelData.ItemPos[a].PyDel++;
        if (LevelData.ItemPos[a].PyDel>=ITEMPYDEL)
        {
          LevelData.ItemPos[a].Py++;
          LevelData.ItemPos[a].PyDel=0;
        }
      }
    }
  }
  return 0;
}

int update_enemies()
{
  int i, a;
  for (i=0;i<LevelData.EnemyCount;i++)
  {
    if (LevelData.EnemyPos[i].Visible)
    {
      LevelData.EnemyPos[i].Colll=LevelData.EnemyPos[i].Collr=FALSE;
      LevelData.EnemyPos[i].fall=TRUE;

      for (a=0;a<Enemy[LevelData.EnemyPos[i].ident].Bitmap1->w;a++)
        if ((LevelData.LevelMask[((LevelData.EnemyPos[i].y+Enemy[LevelData.EnemyPos[i].ident].Bitmap1->h-10)*LevelData.Length)+(LevelData.EnemyPos[i].x/*+LevelData.xoff*/+a)].mask!=0))
          LevelData.EnemyPos[i].fall=FALSE;

      for (a=0;a<Enemy[LevelData.EnemyPos[i].ident].Bitmap1->h;a++)
        if ((LevelData.LevelMask[((LevelData.EnemyPos[i].y-10+a)*LevelData.Length)+(LevelData.EnemyPos[i].x/*+LevelData.xoff*/-1)].mask!=0))
          LevelData.EnemyPos[i].Colll=TRUE;

      for (a=0;a<Enemy[LevelData.EnemyPos[i].ident].Bitmap1->h;a++)
        if ((LevelData.LevelMask[((LevelData.EnemyPos[i].y-10+a)*LevelData.Length)+(LevelData.EnemyPos[i].x+Enemy[LevelData.EnemyPos[i].ident].Bitmap1->w/*+LevelData.xoff*/)].mask!=0))
          LevelData.EnemyPos[i].Collr=TRUE;

      if ((LevelData.EnemyPos[i].x==LevelData.EnemyPos[i].Stop1x) || (LevelData.EnemyPos[i].x==LevelData.EnemyPos[i].Stop2x))
        LevelData.EnemyPos[i].Colll=TRUE;

      if (((LevelData.EnemyPos[i].x+Enemy[LevelData.EnemyPos[i].ident].Bitmap1->w)==LevelData.EnemyPos[i].Stop1x) || ((LevelData.EnemyPos[i].x+Enemy[LevelData.EnemyPos[i].ident].Bitmap1->w)==LevelData.EnemyPos[i].Stop2x))
        LevelData.EnemyPos[i].Collr=TRUE;

      if (LevelData.EnemyPos[i].fall)
        if ((LevelData.EnemyPos[i].y+Enemy[LevelData.EnemyPos[i].ident].Bitmap1->h)<200)
          LevelData.EnemyPos[i].y++;

      if (LevelData.EnemyPos[i].Colll)
      {
        LevelData.EnemyPos[i].xinc=TRUE;
        LevelData.EnemyPos[i].xdec=FALSE;
        LevelData.EnemyPos[i].Colll=FALSE;
      }
      if (LevelData.EnemyPos[i].Collr)
      {
        LevelData.EnemyPos[i].xdec=TRUE;
        LevelData.EnemyPos[i].xinc=FALSE;
        LevelData.EnemyPos[i].Collr=FALSE;
      }

      LevelData.EnemyPos[i].WalkDelay--;

      if ((LevelData.EnemyPos[i].xdec) && (!LevelData.EnemyPos[i].fall) && (LevelData.EnemyPos[i].x>0) && (LevelData.EnemyPos[i].WalkDelay==0))
      {
        LevelData.EnemyPos[i].Dir=0;
        LevelData.EnemyPos[i].x--;
      }
      if ((LevelData.EnemyPos[i].xinc) && (!LevelData.EnemyPos[i].fall) && (LevelData.EnemyPos[i].x<LevelData.Length) && (LevelData.EnemyPos[i].WalkDelay==0))
      {
       LevelData.EnemyPos[i].Dir=1;
       LevelData.EnemyPos[i].x++;
      }
      if (LevelData.EnemyPos[i].WalkDelay<1)
        LevelData.EnemyPos[i].WalkDelay=WALKDELAY;
  
      //  if ((Enemy[i].x+Enemy[i].Bitmap1->w)<(320-LevelData.xoff))
      if (LevelData.EnemyPos[i].Dir==0)
        draw_sprite(Vir1, Enemy[LevelData.EnemyPos[i].ident].Bitmap1, LevelData.EnemyPos[i].x-LevelData.xoff, LevelData.EnemyPos[i].y);
      if (LevelData.EnemyPos[i].Dir==1)
        draw_sprite(Vir1, Enemy[LevelData.EnemyPos[i].ident].Bitmap2, LevelData.EnemyPos[i].x-LevelData.xoff, LevelData.EnemyPos[i].y);
      //textprintf(Vir1, font, 0,0,100, "Cll %i Clr %i xi %i xd %i F %i X %i Y %i", LevelData.EnemyPos[i].Colll, LevelData.EnemyPos[i].Collr, LevelData.EnemyPos[i].xinc, LevelData.EnemyPos[i].xdec, LevelData.EnemyPos[i].fall, LevelData.EnemyPos[i].x, LevelData.EnemyPos[i].y);
    }
    else
    {
      if (LevelData.EnemyPos[i].Py<ENEMYPYMAX)
      {
        text_mode(-1);
        textprintf(Vir1, Pfont, LevelData.EnemyPos[i].x-LevelData.xoff, LevelData.EnemyPos[i].y-LevelData.EnemyPos[i].Py, 125, "%i", (LevelData.EnemyPos[i].ident+1)*100);
        LevelData.EnemyPos[i].PyDel++;
        if (LevelData.EnemyPos[i].PyDel>=ENEMYPYDEL)
        {
          LevelData.EnemyPos[i].Py++;
          LevelData.EnemyPos[i].PyDel=0;
        }
      }
    }
  }
}


int update_player()
{
  int a, px1, px2, py1, py2, UpOk=FALSE;
  Player.fall=TRUE;
  LevelData.Scroll=FALSE;
 // PreventExtraJump=FALSE;
  Player.Colll=Player.Collr=FALSE;
/*  if (Player.y<Player.jumpy-30)
  {
    Player.jump=FALSE;
  }*/
  if ((JumpPathNum>JUMPPATHCOUNT-1))
  {
    Player.jump=FALSE;
  }
/*  if ((!Player.jump) &&
      (_getpixel(Vir1, Player.x+0, Player.y+Player.Bitmap1->h)==0) &&
      (_getpixel(Vir1, Player.x+1, Player.y+Player.Bitmap1->h)==0) &&
      (_getpixel(Vir1, Player.x+2, Player.y+Player.Bitmap1->h)==0) &&
      (_getpixel(Vir1, Player.x+3, Player.y+Player.Bitmap1->h)==0) &&
      (_getpixel(Vir1, Player.x+4, Player.y+Player.Bitmap1->h)==0) &&
      (_getpixel(Vir1, Player.x+5, Player.y+Player.Bitmap1->h)==0) &&
      (_getpixel(Vir1, Player.x+6, Player.y+Player.Bitmap1->h)==0) &&
      (_getpixel(Vir1, Player.x+7, Player.y+Player.Bitmap1->h)==0) &&
      (_getpixel(Vir1, Player.x+8, Player.y+Player.Bitmap1->h)==0) &&
      (_getpixel(Vir1, Player.x+9, Player.y+Player.Bitmap1->h)==0))
  {
    Player.fall=TRUE;
    PreventExtraJump=FALSE;
    //Player.ydec=FALSE;
    //Player.yinc=FALSE;
  }
  else
    PreventExtraJump=FALSE;*/
/*  for (a=0;a<Player.Bitmap1->w;a++)
    if (_getpixel(screen, Player.x+a, Player.y-1)!=0)
      Player.jump=FALSE;
  Player.Colll=FALSE;
  for (a=0;a<Player.Bitmap1->h;a++)
    if (_getpixel(screen, Player.x-1, Player.y+a)!=0)
    {
      //Player.xdec=FALSE;
      //Player.xdecj=FALSE;
      Player.Colll=TRUE;
    }
  Player.Collr=FALSE;
  for (a=0;a<Player.Bitmap1->h;a++)
    if (_getpixel(screen, Player.x+Player.Bitmap1->w, Player.y+a)!=0)
    {
      //Player.xinc=FALSE;
      //Player.xincj=FALSE;
      Player.Collr=TRUE;
    }                   */
/*
  px1=Player.x+LevelData.xoff;
  px2=Player.x+Player.Bitmap1->w+LevelData.xoff;
  py1=Player.y+Player.Bitmap1->h;
  py2=Player.y;

  for (a=0;a<LevelData.ItemCount;a++)
  {
    if ((px2>LevelData.ItemPos[a].x) && (px1<LevelData.ItemPos[a].x+Texture[LevelData.ItemPos[a].ident].Bitmap->w) && (py1==LevelData.ItemPos[a].y) || (Player.jump))
    {
      Player.fall=FALSE;
      PreventExtraJump=FALSE;
    }
    if ((((LevelData.ItemPos[a].y+Texture[LevelData.ItemPos[a].ident].Bitmap->h)>Player.y) && (LevelData.ItemPos[a].y<Player.y+Player.Bitmap1->h)) && ((LevelData.ItemPos[a].x+Texture[LevelData.ItemPos[a].ident].Bitmap->w)==Player.x+LevelData.xoff))
    {
      Player.Colll=TRUE;
    }
    if (((LevelData.ItemPos[a].y+Texture[LevelData.ItemPos[a].ident].Bitmap->h)>Player.y) && (LevelData.ItemPos[a].y<(Player.y+Player.Bitmap1->h)) && (LevelData.ItemPos[a].x==(Player.x+Player.Bitmap1->w+LevelData.xoff)))
    {
      Player.Collr=TRUE;
    }
    if (((LevelData.ItemPos[a].x+Texture[LevelData.ItemPos[a].ident].Bitmap->w)>(Player.x+LevelData.xoff)) && (LevelData.ItemPos[a].x<(Player.x+Player.Bitmap1->w+LevelData.xoff)) && ((LevelData.ItemPos[a].y+Texture[LevelData.ItemPos[a].ident].Bitmap->h)==Player.y))
    {
      Player.jump=FALSE;
      Player.fall=TRUE;
    }
  }
   */
  for (a=0;a<Player.Bitmap1->w;a++)
    if ((LevelData.LevelMask[((Player.y+Player.Bitmap1->h-10+LevelData.yoff)*LevelData.Length)+(Player.x+LevelData.xoff+a)].mask!=0))
      Player.fall=FALSE;

  for (a=0;a<Player.Bitmap1->h;a++)
    if ((LevelData.LevelMask[((Player.y-10+a+LevelData.yoff)*LevelData.Length)+(Player.x+LevelData.xoff-1)].mask!=0))
      Player.Colll=TRUE;

  for (a=0;a<Player.Bitmap1->h;a++)
    if ((LevelData.LevelMask[((Player.y-10+a+LevelData.yoff)*LevelData.Length)+(Player.x+Player.Bitmap1->w+LevelData.xoff)].mask!=0))
      Player.Collr=TRUE;

  for (a=0;a<Player.Bitmap1->w;a++)
    if ((LevelData.LevelMask[((Player.y-10+LevelData.yoff)*LevelData.Length)+(Player.x+LevelData.xoff+a)].mask!=0))
    {
      Player.jump=FALSE;
     // Player.fall=TRUE;
    }
/*  if ((Player.xdec) && (LevelData.LevelMask[((Player.y-11+Player.Bitmap1->h+LevelData.yoff)*LevelData.Length)+(Player.x+LevelData.xoff-1)].mask!=0) && (LevelData.LevelMask[((Player.y-11+Player.Bitmap1->h-1)*LevelData.Length)+(Player.x+LevelData.xoff-1)].mask==0))
  {
    Player.Colll=FALSE;
    Player.y--;
  }
  if ((Player.xinc) && (LevelData.LevelMask[((Player.y-11+Player.Bitmap1->h+LevelData.yoff)*LevelData.Length)+(Player.x+Player.Bitmap1->w+LevelData.xoff)].mask!=0) && (LevelData.LevelMask[((Player.y-11+Player.Bitmap1->h-1)*LevelData.Length)+(Player.x+Player.Bitmap1->w+LevelData.xoff)].mask!=0))
  {
    Player.Collr=FALSE;
    Player.y--;
  }*/
/*  UpOk=FALSE;
  putpixel(Vir1, Player.x+Player.Bitmap1->w, Player.y+Player.Bitmap1->h, 100);
  if ((LevelData.LevelMask[((Player.y-11+Player.Bitmap1->h+LevelData.yoff)*LevelData.Length)+Player.x+Player.Bitmap1->w+LevelData.xoff].mask!=0))
    UpOk=TRUE;
  for (a=1;a<Player.Bitmap1->h;a++)
    if ((LevelData.LevelMask[((Player.y-11+Player.Bitmap1->h+LevelData.yoff-a)*LevelData.Length)+Player.x+Player.Bitmap1->w+LevelData.xoff].mask!=0))
      UpOk=FALSE;
  if (UpOk)
  {
    Player.Collr=FALSE;
    Player.y--;
  }
  UpOk=FALSE;
  if (UpOk)
  {
    Player.Colll=FALSE;
    Player.y--;
  }*/
  for (a=0;a<LevelData.EnemyCount;a++)
  {
    if (LevelData.EnemyPos[a].Visible)
    {
      if (((LevelData.EnemyPos[a].y+Enemy[LevelData.EnemyPos[a].ident].Bitmap1->h)>Player.y+LevelData.yoff) && (LevelData.EnemyPos[a].y<(Player.y+Player.Bitmap1->h+LevelData.yoff)) && (LevelData.EnemyPos[a].x==(Player.x+Player.Bitmap1->w+LevelData.xoff)))
        if (!Player.Blink)
        {
          if (!NOMUSIC)
            SndSample[1].Handle=MIDASplaySample(SndSample[1].Sample, MIDAS_CHANNEL_AUTO, 0, 22050, SfxVol, MIDAS_PAN_MIDDLE);
          player_hurt();
        }
      if (((LevelData.EnemyPos[a].y+Enemy[LevelData.EnemyPos[a].ident].Bitmap1->h)>Player.y+LevelData.yoff) && (LevelData.EnemyPos[a].y<(Player.y+Player.Bitmap1->h+LevelData.yoff)) && ((LevelData.EnemyPos[a].x+Enemy[LevelData.EnemyPos[a].ident].Bitmap1->w)==(Player.x+LevelData.xoff)))
        if (!Player.Blink)
        {
          if (!NOMUSIC)
            SndSample[1].Handle=MIDASplaySample(SndSample[1].Sample, MIDAS_CHANNEL_AUTO, 0, 22050, SfxVol, MIDAS_PAN_MIDDLE);
          player_hurt();
        }
      if (((LevelData.EnemyPos[a].x+Enemy[LevelData.EnemyPos[a].ident].Bitmap1->w)>(Player.x+LevelData.xoff)) && (LevelData.EnemyPos[a].x<(Player.x+Player.Bitmap1->w+LevelData.xoff)) && (LevelData.EnemyPos[a].y==(Player.y+Player.Bitmap1->h+LevelData.yoff)) && (!Player.jump))
      {
        if (!NOMUSIC)
          SndSample[0].Handle=MIDASplaySample(SndSample[0].Sample, MIDAS_CHANNEL_AUTO, 0, 22050, SfxVol, MIDAS_PAN_MIDDLE);
        LevelData.EnemyPos[a].Visible=FALSE;
        LevelData.EnemyPos[a].Py=0;
        LevelData.EnemyPos[a].PyDel=0;
        Player.Score+=(LevelData.EnemyPos[a].ident+1)*100;
        Player.jump=TRUE;
      }
    }
  }
/*  if (Player.y+LevelData.yoff+Player.Bitmap1->h>199)
  {
    if (!NOMUSIC)
      SndSample[1].Handle=MIDASplaySample(SndSample[1].Sample, MIDAS_CHANNEL_AUTO, 0, 22050, SfxVol, MIDAS_PAN_MIDDLE);
    player_die();
  }*/
  for (a=0;a<LevelData.ItemCount;a++)
  {
    if ((LevelData.ItemPos[a].x<(Player.x+Player.Bitmap1->w+LevelData.xoff)) && ((LevelData.ItemPos[a].x+Item[LevelData.ItemPos[a].ident].Bitmap1->w)>(Player.x+LevelData.xoff)) && ((LevelData.ItemPos[a].y+Item[LevelData.ItemPos[a].ident].Bitmap1->h+10)==Player.y+LevelData.yoff) && (LevelData.ItemPos[a].Visible))
    {
      LevelData.ItemPos[a].Visible=FALSE;
      LevelData.ItemPos[a].Py=0;
      LevelData.ItemPos[a].PyDel=0;
      Player.Score+=(LevelData.ItemPos[a].ident+1)*25;
      if (!NOMUSIC)
        SndSample[1].Handle=MIDASplaySample(SndSample[1].Sample, MIDAS_CHANNEL_AUTO, 0, 22050, SfxVol, MIDAS_PAN_MIDDLE);
    }
    if (((LevelData.ItemPos[a].y+Item[LevelData.ItemPos[a].ident].Bitmap1->h+10)>Player.y+LevelData.yoff) && ((LevelData.ItemPos[a].y+10)<(Player.y+Player.Bitmap1->h+LevelData.yoff)) && (LevelData.ItemPos[a].x==(Player.x+Player.Bitmap1->w+LevelData.xoff)) && (LevelData.ItemPos[a].Visible))
    {
      LevelData.ItemPos[a].Visible=FALSE;
      LevelData.ItemPos[a].Py=0;
      LevelData.ItemPos[a].PyDel=0;
      Player.Score+=(LevelData.ItemPos[a].ident+1)*25;
      if (!NOMUSIC)
        SndSample[1].Handle=MIDASplaySample(SndSample[1].Sample, MIDAS_CHANNEL_AUTO, 0, 22050, SfxVol, MIDAS_PAN_MIDDLE);
    }
    if (((LevelData.ItemPos[a].y+Item[LevelData.ItemPos[a].ident].Bitmap1->h+10)>Player.y+LevelData.yoff) && ((LevelData.ItemPos[a].y+10)<(Player.y+Player.Bitmap1->h+LevelData.yoff)) && ((LevelData.ItemPos[a].x+Item[LevelData.ItemPos[a].ident].Bitmap1->w)==(Player.x+LevelData.xoff)) && (LevelData.ItemPos[a].Visible))
    {
      LevelData.ItemPos[a].Visible=FALSE;
      LevelData.ItemPos[a].Py=0;
      LevelData.ItemPos[a].PyDel=0;
      Player.Score+=(LevelData.ItemPos[a].ident+1)*25;
      if (!NOMUSIC)
        SndSample[1].Handle=MIDASplaySample(SndSample[1].Sample, MIDAS_CHANNEL_AUTO, 0, 22050, SfxVol, MIDAS_PAN_MIDDLE);
    }
    if ((LevelData.ItemPos[a].x<(Player.x+Player.Bitmap1->w+LevelData.xoff)) && ((LevelData.ItemPos[a].x+Item[LevelData.ItemPos[a].ident].Bitmap1->w)>(Player.x+LevelData.xoff)) && ((LevelData.ItemPos[a].y+10)==(Player.y+Player.Bitmap1->h+LevelData.yoff)) && (LevelData.ItemPos[a].Visible))
    {
      LevelData.ItemPos[a].Visible=FALSE;
      LevelData.ItemPos[a].Py=0;
      LevelData.ItemPos[a].PyDel=0;
      Player.Score+=(LevelData.ItemPos[a].ident+1)*25;
      if (!NOMUSIC)
        SndSample[1].Handle=MIDASplaySample(SndSample[1].Sample, MIDAS_CHANNEL_AUTO, 0, 22050, SfxVol, MIDAS_PAN_MIDDLE);
    }
  }

  if (Player.jump)
    Player.fall=FALSE;

  if (Player.fall)
  {
    if (Player.y<(200-Player.Bitmap1->h))
      Player.y+=JumpPath[JumpPathNum];
    if (JumpPathNum>0)
      JumpPathNum--;
  }
  if (((Player.xdec) || (Player.xdecj)) && (!Player.Colll))
    if (Player.x>0)
      Player.x--;
  if (((Player.xinc) || (Player.xincj)) && (!Player.Collr))
    if (Player.x<(320-Player.Bitmap1->w))
      Player.x++;
  if (Player.jump)
  {
    Player.y-=JumpPath[JumpPathNum];
    if (JumpPathNum<JUMPPATHCOUNT)
      JumpPathNum++;
  }
/*  if (Player.yinc)
    Player.y++;*/
  if ((Player.x>(320-100)))
    if (LevelData.xoff<(LevelData.Length-320))
    {
     LevelData.xoff++;
     Player.x--;
     LevelData.Scroll=TRUE;
    }
  if ((Player.x<100))
    if (LevelData.xoff>0)
    {
      LevelData.xoff--;
      Player.x++;
      LevelData.Scroll=TRUE;
    }
  if ((Player.y>(200-50)))
    if (LevelData.yoff<(LevelData.Height-200))
    {
     LevelData.yoff++;
     Player.y--;
     LevelData.Scroll=TRUE;
    }
  if ((Player.y<100))
    if (LevelData.yoff>0)
    {
      LevelData.yoff--;
      Player.y++;
      LevelData.Scroll=TRUE;
    }
  //masked_blit(Player.Bitmap, Vir1, 0, 0, Player.x, Player.y, Player.Bitmap->w, Player.Bitmap->h);
  if ((Player.xinc) || (Player.xdec))
  {
    if (FotChange>=FOTCHANGECOUNT)
    {
      FotChange=0;
      if (Player.fot==1)
        Player.fot=0;
      else
        Player.fot=1;
    }
    FotChange++;
  }
  if (Player.Blink)
  {
    Player.BlinkCount--;
    if (Player.BlinkCount<1)
    {
      Player.BlinkCount=PLAYERBLINK;
      Player.Blink=FALSE;
    }
    if (Player.BlinkCount % 2 == 0)
    {
      if (Player.Dir==0)
      {
        if (Player.fot==0)
          draw_sprite(Vir1, Player.Bitmap1, Player.x, Player.y);
        if (Player.fot==1)
          draw_sprite(Vir1, Player.Bitmap2, Player.x, Player.y);
      }
      if (Player.Dir==1)
      {
        if (Player.fot==0)
          draw_sprite(Vir1, Player.Bitmap3, Player.x, Player.y);
        if (Player.fot==1)
          draw_sprite(Vir1, Player.Bitmap4, Player.x, Player.y);
      }
      if (Player.Dir==2)
      {
        if (Player.fot==0)
          draw_sprite(Vir1, Player.Bitmap5, Player.x, Player.y);
        if (Player.fot==1)
          draw_sprite(Vir1, Player.Bitmap6, Player.x, Player.y);
      }
    }
  }
  else
  {
    if (Player.Dir==0)
    {
      if (Player.fot==0)
        draw_sprite(Vir1, Player.Bitmap1, Player.x, Player.y);
      if (Player.fot==1)
        draw_sprite(Vir1, Player.Bitmap2, Player.x, Player.y);
    }
    if (Player.Dir==1)
    {
      if (Player.fot==0)
        draw_sprite(Vir1, Player.Bitmap3, Player.x, Player.y);
      if (Player.fot==1)
        draw_sprite(Vir1, Player.Bitmap4, Player.x, Player.y);
    }
    if (Player.Dir==2)
    {
      if (Player.fot==0)
        draw_sprite(Vir1, Player.Bitmap5, Player.x, Player.y);
      if (Player.fot==1)
        draw_sprite(Vir1, Player.Bitmap6, Player.x, Player.y);
    }
  }
}


int get_input()     // Hmtar aktuell knapptryckning och joystick data
{
  if (keypressed())
  {
    gKey=readkey();
  }
  if (joyen)
  {
    poll_joystick();
  }
  return 0;
}

int load_level(char *filename)
{
  FILE *F;
  char *temp;
  int i, j;
  unsigned char BlockType;
  unsigned int x,y;
  unsigned int ItemCount;
  if (DEBUG)
    printf("Loading level: %s\n", filename);
  F=fopen(filename, "r");
  if (F==0)
  {
     equit("Error opening file!");
  }
  else
  {
    fgets(temp, 7, F);  // Kollar om filen har rtt format
    if (strcmp(temp, "LGL100")!=0)
      equit("Wrong filetype!");
    else
    {    // Laddar banans namn
      fgets(LevelData.Name, 20, F);
      fgetc(F);
      LevelData.ident=fgetc(F);   // Identifikationsnummer
      if (DEBUG)
        printf("Ident: %i\n", LevelData.ident);
      LevelData.Length=fgetc(F);  // Banans lngd i pixlar
      LevelData.Length=(LevelData.Length << 8);
      LevelData.Length+=fgetc(F);
      if (DEBUG)
        printf("Length: %i\n", LevelData.Length);
      LevelData.Height=fgetc(F);  // Banans lngd i pixlar
      LevelData.Height=(LevelData.Height << 8);
      LevelData.Height+=fgetc(F);
      if (DEBUG)
        printf("Height: %i\n", LevelData.Height);
      LevelData.BlockCount=fgetc(F);  // Antal block i banan
      LevelData.BlockCount=(LevelData.BlockCount << 8);
      LevelData.BlockCount+=fgetc(F);
      if (DEBUG)
        printf("BlockCount: %i\n", LevelData.BlockCount);
      LevelData.EnemyCount=fgetc(F);   // Antal fiender p banan
      LevelData.EnemyCount=(LevelData.EnemyCount << 8);
      LevelData.EnemyCount+=fgetc(F);
      if (DEBUG)
        printf("EnemyCount: %i\n", LevelData.EnemyCount);
      LevelData.ItemCount=fgetc(F);   // Antal prylar och saker p banan
      LevelData.ItemCount=(LevelData.ItemCount << 8);
      LevelData.ItemCount+=fgetc(F);
      if (DEBUG)
        printf("ItemCount: %i\n", LevelData.ItemCount);
      Player.x=fgetc(F);   // Player start X
      Player.x=(Player.x << 8);
      Player.x+=fgetc(F);
      if (DEBUG)
        printf("Player.x: %i\n", Player.x);
      Player.y=fgetc(F);   // Player start Y
      Player.y=(Player.y << 8);
      Player.y+=fgetc(F);
      Player.StartX=Player.x;
      Player.StartY=Player.y;
      if (DEBUG)
        printf("Player.y: %i\n", Player.y);
      // printf("Loading %s - %i\n", LevelData.Name, LevelData.Ident);
      if (DEBUG)
        printf("Allokerar minne...\n");
      LevelData.LevelBitmap=create_bitmap(LevelData.Length, LevelData.Height);   // Allokerar minne fr banbitmappen
      LevelData.LevelBackgr=create_bitmap(LevelData.Length, LevelData.Height);   // Allokerar minne fr banbitmappen
      LevelData.LevelMask=malloc(sizeof(struct TLevelMask)*((LevelData.Length*LevelData.Height)+10));  //Allokerar minne fr collisionmasken
      if (LevelData.LevelMask==0)
        equit("Not enough memory...");
      LevelData.BlockPos=malloc(sizeof(struct TItemPos)*LevelData.BlockCount+10);  // Allokerar minne fr block
      if (LevelData.BlockPos==0)
        equit("Not enough memory...");
      LevelData.EnemyPos=malloc(sizeof(struct TItemPos)*LevelData.EnemyCount+10);  // Allokerar minne fr fiender
      if (LevelData.EnemyPos==0)
        equit("Not enough memory...");
      LevelData.ItemPos=malloc(sizeof(struct TItemPos)*LevelData.ItemCount+10);    // Allokerar minne fr saker
      if (LevelData.ItemPos==0)
        equit("Not enough memory...");
      memset(LevelData.LevelMask, 0, (LevelData.Length*LevelData.Height)+10);          // Nollstller alla allokerade minnesplatser
      memset(LevelData.BlockPos, 0, LevelData.BlockCount+10);
      memset(LevelData.EnemyPos, 0, LevelData.EnemyCount+10);
      memset(LevelData.ItemPos, 0, LevelData.ItemCount+10);
      clear(LevelData.LevelBitmap);
      clear(LevelData.LevelBackgr);
      for (i=0;i<LevelData.Length/320;i++)
      {
        blit(LevelData.Background, LevelData.LevelBackgr, 0,10,320*i,0,320,190);
      }
      if (LevelData.Length-(LevelData.Length/320)!=0)
      {
        blit(LevelData.Background, LevelData.LevelBackgr, 0,10,320*(LevelData.Length/320),0,LevelData.Length-(LevelData.Length/320),190);
      }
      if ((LevelData.LevelBitmap==NULL) || (LevelData.LevelBackgr==NULL))
        equit("Error creating bitmaps!");
      else // Ladda sjlva banan...
      {
        if (DEBUG)
          printf("Laddar koordinater till block\n");
        for (i=0;i<LevelData.BlockCount;i++)
        {
          BlockType=fgetc(F);  // Hmta blocktypen
          if (BlockType<BlockTextureCount)  // Kontrollera om det r ett felaktigt block
          {
            if (DEBUG)
              printf(".");
            x=fgetc(F);   // Hmta X och Y position fr blocket
            x=(x << 8);
            x+=fgetc(F);
            y=fgetc(F);
            y=(y << 8);
            y+=fgetc(F);
            masked_blit(Texture[BlockType].Bitmap, LevelData.LevelBitmap,  0, 0, x, y, Texture[BlockType].Width, Texture[BlockType].Height);
            LevelData.BlockPos[i].x=x;  // Sparar blocket i minnet
            LevelData.BlockPos[i].y=y;
            LevelData.BlockPos[i].ident=BlockType;
            x=fgetc(F);   // Hmta X och Y position fr Stopp 1
            x=(x << 8);
            x+=fgetc(F);
            y=fgetc(F);
            y=(y << 8);
            y+=fgetc(F);
            LevelData.BlockPos[i].Stop1x=x;
            LevelData.BlockPos[i].Stop1y=y;
            x=fgetc(F);   // Hmta X och Y position fr Stopp 2
            x=(x << 8);
            x+=fgetc(F);
            y=fgetc(F);
            y=(y << 8);
            y+=fgetc(F);
            LevelData.BlockPos[i].Stop2x=x;
            LevelData.BlockPos[i].Stop2y=y;
          }
        }
        if (DEBUG)
          printf("\nLaddar koordinater till fiender\n");
        for (i=0;i<LevelData.EnemyCount;i++)  // Samma som ovan fast fr fiender
        {
          BlockType=fgetc(F);
          if (BlockType<EnemyTextureCount)
          {
            if (DEBUG)
              printf(".");
            x=fgetc(F);
            x=(x << 8);
            x+=fgetc(F);
            y=fgetc(F);
            y=(y << 8);
            y+=fgetc(F);
            //masked_blit(Enemy[BlockType].Bitmap1, LevelData.LevelBitmap,  0, 0, x, y, Enemy[BlockType].Bitmap1->w, Enemy[BlockType].Bitmap1->h);
            LevelData.EnemyPos[i].x=x;
            LevelData.EnemyPos[i].y=y;//+10
            LevelData.EnemyPos[i].StartX=x;
            LevelData.EnemyPos[i].StartY=y;//+10
            LevelData.EnemyPos[i].ident=BlockType;
            LevelData.EnemyPos[i].xdec=TRUE;
            LevelData.EnemyPos[i].xinc=FALSE;
            LevelData.EnemyPos[i].WalkDelay=WALKDELAY;
            LevelData.EnemyPos[i].Visible=TRUE;
            x=fgetc(F);   // Hmta X och Y position fr Stopp 1
            x=(x << 8);
            x+=fgetc(F);
            y=fgetc(F);
            y=(y << 8);
            y+=fgetc(F);
            LevelData.EnemyPos[i].Stop1x=x;
            LevelData.EnemyPos[i].Stop1y=y;
           // printf("[X1: %i]", x);
            x=fgetc(F);   // Hmta X och Y position fr Stopp 2
            x=(x << 8);
            x+=fgetc(F);
            y=fgetc(F);
            y=(y << 8);
            y+=fgetc(F);
            LevelData.EnemyPos[i].Stop2x=x;
            LevelData.EnemyPos[i].Stop2y=y;
           // printf("[X2: %i]", x);
          }
        }
        if (DEBUG)
          printf("\nLaddar koordinater till saker\n");
        for (i=0;i<LevelData.ItemCount;i++)   // Samma som ovan fast fr saker
        {
          BlockType=fgetc(F);
        /*  if (DEBUG)
            printf("[%i]", BlockType);*/
          if (BlockType<ItemTextureCount)
          {
            if (DEBUG)
              printf(".");
            x=fgetc(F);
            x=(x << 8);
            x+=fgetc(F);
            y=fgetc(F);
            y=(y << 8);
            y+=fgetc(F);
            //masked_blit(Item[BlockType].Bitmap1, LevelData.LevelBitmap,  0, 0, x, y, Item[BlockType].Bitmap1->w, Item[BlockType].Bitmap1->h);
            LevelData.ItemPos[i].x=x;
            LevelData.ItemPos[i].y=y;
            LevelData.ItemPos[i].ident=BlockType;
            LevelData.ItemPos[i].Visible=TRUE;
            x=fgetc(F);   // Hmta X och Y position fr Stopp 1
            x=(x << 8);
            x+=fgetc(F);
            y=fgetc(F);
            y=(y << 8);
            y+=fgetc(F);
            LevelData.ItemPos[i].Stop1x=x;
            LevelData.ItemPos[i].Stop1y=y;
            x=fgetc(F);   // Hmta X och Y position fr Stopp 2
            x=(x << 8);
            x+=fgetc(F);
            y=fgetc(F);
            y=(y << 8);
            y+=fgetc(F);
            LevelData.ItemPos[i].Stop2x=x;
            LevelData.ItemPos[i].Stop2y=y;
          }
        }
      }
    }
    if (DEBUG)
      printf("\nSkapar LevelMask...\n");
    for (i=0;i<LevelData.Height;i++)
    {
      for (j=0;j<LevelData.Length;j++)
      {
        if (getpixel(LevelData.LevelBitmap, j, i)>0)
        LevelData.LevelMask[(i*LevelData.Length)+j].mask=1;
        else
        LevelData.LevelMask[(i*LevelData.Length)+j].mask=0;
      }
    }
    if (DEBUG)
      printf("Klart!\n");
  }
  fclose(F);
  return 0;
}

int unload_level()
{
  int a;
  if (LevelData.LevelBitmap!=NULL)
    destroy_bitmap(LevelData.LevelBitmap);
  if (LevelData.LevelBackgr!=NULL)
    destroy_bitmap(LevelData.LevelBackgr);
  LevelData.Length=0;
  for (a=0;a<20;a++)
    LevelData.Name[a]=' ';
  LevelData.ident=0;
  LevelData.BlockCount=0;
  LevelData.EnemyCount=0;
  LevelData.ItemCount=0;
  free(LevelData.LevelMask);
  free(LevelData.BlockPos);
  free(LevelData.EnemyPos);
  free(LevelData.ItemPos);
  return 0;
}


int design_new_level(char *filename)
{
  FILE *F;
  int ActiveItem=0, ActiveEnemy=0, ActiveTexture=0, draw=TRUE, done=FALSE, change_text=TRUE, Delete=FALSE;
  int a;
  BITMAP *TempBitmap, *PlayerStartBitmap, *EnemyStop1Bitmap, *EnemyStop2Bitmap;
  int DeleteType=1000;

  char *temp;
  int i, j;
  unsigned char BlockType;
  unsigned int x,y;
//  unsigned int BlockCount=0, ItemCount=0, EnemyCount=0;
  int ItemType=0;

  // On filen finns s ppna ladda den i minnet
  // Om inte skapa en ny

  if (exists(filename)!=0)
  {
/*    load_level!!!!*/
    if (DEBUG)
      printf("ppnar en existerande fil\n");
    F=fopen(filename, "r");
    if (F==0)
    {
       equit("Cant open file!");
    }
    else
    {
      fgets(temp, 7, F);  // Kollar om filen har rtt format
      if (strcmp(temp, "LGL100")!=0)
        equit("Wrong filetype!\n");
      else
      {    // Laddar banans namn
        fgets(LevelData.Name, 20, F);
        fgetc(F);
        LevelData.ident=fgetc(F);   // Identifikationsnummer
        LevelData.Length=fgetc(F);  // Banans lngd i pixlar
        LevelData.Length=(LevelData.Length << 8);
        LevelData.Length+=fgetc(F);
        LevelData.Height=fgetc(F);  // Banans hjd i pixlar
        LevelData.Height=(LevelData.Height << 8);
        LevelData.Height+=fgetc(F);
        LevelData.BlockCount=fgetc(F);  // Antal block i banan
        LevelData.BlockCount=(LevelData.BlockCount << 8);
        LevelData.BlockCount+=fgetc(F);
        LevelData.EnemyCount=fgetc(F);   // Antal fiender p banan
        LevelData.EnemyCount=(LevelData.EnemyCount << 8);
        LevelData.EnemyCount+=fgetc(F);
        LevelData.ItemCount=fgetc(F);   // Antal prylar och saker p banan
        LevelData.ItemCount=(LevelData.ItemCount << 8);
        LevelData.ItemCount+=fgetc(F);
        Player.x=fgetc(F);   // Player start X
        Player.x=(Player.x << 8);
        Player.x+=fgetc(F);
        Player.y=fgetc(F);   // Player start Y
        Player.y=(Player.y << 8);
        Player.y+=fgetc(F);
        Player.StartX=Player.x;
        Player.StartY=Player.y;
        if (DEBUG)
          printf("Skapar bitmaps och allokerar minne\n");
       // printf("Loading %s - %i\n", LevelData.Name, LevelData.Ident);
        LevelData.LevelBitmap=create_bitmap(LevelData.Length, LevelData.Height);   // Allokerar minne fr banbitmappen
        //LevelData.LevelMask=malloc(sizeof(struct TLevelMask)*((LevelData.Length*190)+10));  //Allokerar minne fr collisionmasken
        LevelData.BlockPos=malloc(sizeof(struct TItemPos)*(LevelData.BlockCount+10));  // Allokerar minne fr block
        LevelData.EnemyPos=malloc(sizeof(struct TItemPos)*(LevelData.EnemyCount+10));  // Allokerar minne fr fiender
        LevelData.ItemPos=malloc(sizeof(struct TItemPos)*(LevelData.ItemCount+10));    // Allokerar minne fr saker
        //memset(LevelData.LevelMask, 0, (LevelData.Length*190)+10);          // Nollstller alla allokerade minnesplatser
        if (DEBUG)
          printf("Nollstller minne\n");
        memset(LevelData.BlockPos, 0, LevelData.BlockCount+10);
        memset(LevelData.EnemyPos, 0, LevelData.EnemyCount+10);
        memset(LevelData.ItemPos, 0, LevelData.ItemCount+10);
        clear(LevelData.LevelBitmap);
        if ((LevelData.LevelBitmap==NULL))
          equit("Error creating bitmaps!");
        else // Ladda sjlva banan...
        {
          if (DEBUG)
            printf("Laddar blockdata");
          for (i=0;i<LevelData.BlockCount;i++)
          {
            BlockType=fgetc(F);  // Hmta blocktypen
            if (BlockType<BlockTextureCount)  // Kontrollera om det r ett felaktigt block
            {
              x=fgetc(F);   // Hmta X och Y position fr blocket
              x=(x << 8);
              x+=fgetc(F);
              y=fgetc(F);
              y=(y << 8);
              y+=fgetc(F);
              masked_blit(Texture[BlockType].Bitmap, LevelData.LevelBitmap,  0, 0, x, y, Texture[BlockType].Width, Texture[BlockType].Height);
              LevelData.BlockPos[i].x=x;  // Sparar blocket i minnet
              LevelData.BlockPos[i].y=y;
              LevelData.BlockPos[i].ident=BlockType;
              x=fgetc(F);   // Hmta X och Y position fr Stopp 1
              x=(x << 8);
              x+=fgetc(F);
              y=fgetc(F);
              y=(y << 8);
              y+=fgetc(F);
              LevelData.BlockPos[i].Stop1x=x;
              LevelData.BlockPos[i].Stop1y=y;
              x=fgetc(F);   // Hmta X och Y position fr Stopp 2
              x=(x << 8);
              x+=fgetc(F);
              y=fgetc(F);
              y=(y << 8);
              y+=fgetc(F);
              LevelData.BlockPos[i].Stop2x=x;
              LevelData.BlockPos[i].Stop2y=y;
            }
          }
          if (DEBUG)
            printf("Laddar fiende");
          for (i=0;i<LevelData.EnemyCount;i++)  // Samma som ovan fast fr fiender
          {
            BlockType=fgetc(F);
            if (BlockType<EnemyTextureCount)
            {
              x=fgetc(F);
              x=(x << 8);
              x+=fgetc(F);
              y=fgetc(F);
              y=(y << 8);
              y+=fgetc(F);
              masked_blit(Enemy[BlockType].Bitmap1, LevelData.LevelBitmap,  0, 0, x, y, Enemy[BlockType].Bitmap1->w, Enemy[BlockType].Bitmap1->h);
              LevelData.EnemyPos[i].x=x;
              LevelData.EnemyPos[i].y=y;//+10
              LevelData.EnemyPos[i].StartX=x;
              LevelData.EnemyPos[i].StartY=y;//+10
              LevelData.EnemyPos[i].ident=BlockType;
              LevelData.EnemyPos[i].WalkDelay=WALKDELAY;
              LevelData.EnemyPos[i].Visible=TRUE;
              x=fgetc(F);   // Hmta X och Y position fr Stopp 1
              x=(x << 8);
              x+=fgetc(F);
              y=fgetc(F);
              y=(y << 8);
              y+=fgetc(F);
              LevelData.EnemyPos[i].Stop1x=x;
              LevelData.EnemyPos[i].Stop1y=y;
              x=fgetc(F);   // Hmta X och Y position fr Stopp 2
              x=(x << 8);
              x+=fgetc(F);
              y=fgetc(F);
              y=(y << 8);
              y+=fgetc(F);
              LevelData.EnemyPos[i].Stop2x=x;
              LevelData.EnemyPos[i].Stop2y=y;
            }
          }
          if (DEBUG)
            printf("Laddar sakdata");
          for (i=0;i<LevelData.ItemCount;i++)   // Samma som ovan fast fr saker
          {
            BlockType=fgetc(F);
            if (BlockType<ItemTextureCount)
            {
              x=fgetc(F);
              x=(x << 8);
              x+=fgetc(F);
              y=fgetc(F);
              y=(y << 8);
              y+=fgetc(F);
              masked_blit(Item[BlockType].Bitmap1, LevelData.LevelBitmap,  0, 0, x, y, Item[BlockType].Bitmap1->w, Item[BlockType].Bitmap1->h);
              LevelData.ItemPos[i].x=x;
              LevelData.ItemPos[i].y=y;
              LevelData.ItemPos[i].ident=BlockType;
              LevelData.ItemPos[i].Visible=TRUE;
              x=fgetc(F);   // Hmta X och Y position fr Stopp 1
              x=(x << 8);
              x+=fgetc(F);
              y=fgetc(F);
              y=(y << 8);
              y+=fgetc(F);
              LevelData.ItemPos[i].Stop1x=x;
              LevelData.ItemPos[i].Stop1y=y;
              x=fgetc(F);   // Hmta X och Y position fr Stopp 2
              x=(x << 8);
              x+=fgetc(F);
              y=fgetc(F);
              y=(y << 8);
              y+=fgetc(F);
              LevelData.ItemPos[i].Stop2x=x;
              LevelData.ItemPos[i].Stop2y=y;
            }
          }
          textout(LevelData.LevelBitmap, font, "PS", Player.x, Player.y, 125);
        }
      }
    }
    fclose(F);

    // Anledningen till att jag inte kr load_level(char *filename) r att det krnglar lngre ner
/*loadlevel end*/

  }
  else
  {                  // Om banan nu redan skulle vara allokerad s tycker i alla fall jag att den ska avallokeras...  Eller vad sger du?
    if (DEBUG)
      printf("Skapar ny fil\n");
    LevelData.Length=320;
    LevelData.Height=200;
    if (LevelData.LevelBitmap!=NULL)
      unload_level();
    LevelData.BlockCount=0;
    LevelData.EnemyCount=0;
    LevelData.ItemCount=0;
    if (DEBUG)
      printf("Skapar bitmap och allokerar minne\n");
    LevelData.LevelBitmap=create_bitmap(LevelData.Length, LevelData.Height);   // Allokerar minne fr banbitmappen
    LevelData.BlockPos=malloc(sizeof(struct TItemPos)*(LevelData.BlockCount+10));  // Allokerar minne fr block
    LevelData.EnemyPos=malloc(sizeof(struct TItemPos)*(LevelData.EnemyCount+10));  // Allokerar minne fr fiender
    LevelData.ItemPos=malloc(sizeof(struct TItemPos)*(LevelData.ItemCount+10));    // Allokerar minne fr saker
    if (DEBUG)
      printf("Nollstller minne\n");
    memset(LevelData.BlockPos, 0, LevelData.BlockCount+10);
    memset(LevelData.EnemyPos, 0, LevelData.EnemyCount+10);
    memset(LevelData.ItemPos, 0, LevelData.ItemCount+10);
    LevelData.LevelBitmap=create_bitmap(320, 200);
    clear(LevelData.LevelBitmap);
  }
  if (DEBUG)
    printf("Start...\n");
  clear(screen);
  set_mouse_range(0,0,320,200);  // Ange grnserna fr hur musen fr flyttas
  position_mouse(0,0);           // och stt vart den ska brja
  set_palette(Texture[0].Pal);
  PlayerStartBitmap=create_bitmap(2*8, 8);
  clear(PlayerStartBitmap);
  textout(PlayerStartBitmap, font, "PS", 0, 0, 125);
  EnemyStop1Bitmap=create_bitmap(5*8, 8);
  clear(EnemyStop1Bitmap);
  textout(EnemyStop1Bitmap, font, "Stop1", 0, 0, 125);
  EnemyStop2Bitmap=create_bitmap(5*8, 8);
  clear(EnemyStop2Bitmap);
  textout(EnemyStop2Bitmap, font, "Stop2", 0, 0, 125);
  if (ItemType==0)
    set_mouse_sprite(Texture[ActiveTexture].Bitmap);  // Fixar till s att vi kan se en snygg (?) sprite istllet fr den hemska pilen :)
  if (ItemType==1)
    set_mouse_sprite(Enemy[ActiveEnemy].Bitmap1);
  if (ItemType==2)
    set_mouse_sprite(Item[ActiveItem].Bitmap1);
  if (ItemType==3)
    set_mouse_sprite(PlayerStartBitmap);
  textout(screen, font, MENUTEXT, 0,0,250);  // Jaja  Vi initierar en massa shit...
  hline(screen, 0, 9, 320, 100);
  show_mouse(screen);
  LevelData.xoff=0;
  LevelData.yoff=0;
  LevelData.xinc=LevelData.xdec=FALSE;
  LevelData.yinc=LevelData.ydec=FALSE;
  blit(LevelData.LevelBitmap, screen, 0,0,0,10,320,190);
  while (!done)
  {
    //textprintf(screen, font, 0,50,125,"[%i]     ", key_shifts & 0x000F);
    gKey=0;   // Denna mste nollstllas annars s blir det cp
    get_input();
    switch(gKey)  // Tangenttryckningar
    {
      case 283:   done=TRUE;  // Esc
                  break;
      case 4709:  if (ItemType==0)
                    position_mouse(mouse_x, mouse_y - Texture[ActiveTexture].Height);  // e
                  if (ItemType==1)
                    position_mouse(mouse_x, mouse_y - Enemy[ActiveEnemy].Bitmap1->h);  // e
                  if (ItemType==2)
                    position_mouse(mouse_x, mouse_y - Item[ActiveItem].Bitmap1->h);  // e
                  if (ItemType==3)
                    position_mouse(mouse_x, mouse_y - PlayerStartBitmap->h);  // e
                  break;
      case 8550:  if (ItemType==0)
                    position_mouse(mouse_x + Texture[ActiveTexture].Width, mouse_y);   // f
                  if (ItemType==1)
                    position_mouse(mouse_x + Enemy[ActiveEnemy].Bitmap1->w, mouse_y);   // f
                  if (ItemType==2)
                    position_mouse(mouse_x + Item[ActiveItem].Bitmap1->w, mouse_y);   // f
                  if (ItemType==3)
                    position_mouse(mouse_x + PlayerStartBitmap->w, mouse_y);   // f
                  break;
      case 8292:  if (ItemType==0)
                    position_mouse(mouse_x, mouse_y + Texture[ActiveTexture].Height);  // d
                  if (ItemType==1)
                    position_mouse(mouse_x, mouse_y + Enemy[ActiveEnemy].Bitmap1->h);  // d
                  if (ItemType==2)
                    position_mouse(mouse_x, mouse_y + Item[ActiveItem].Bitmap1->h);  // d
                  if (ItemType==3)
                    position_mouse(mouse_x, mouse_y + PlayerStartBitmap->h);  // d
                  break;
      case 8051:  if (ItemType==0)
                    position_mouse(mouse_x - Texture[ActiveTexture].Width, mouse_y);   // s
                  if (ItemType==1)
                    position_mouse(mouse_x - Enemy[ActiveEnemy].Bitmap1->w, mouse_y);   // s
                  if (ItemType==2)
                    position_mouse(mouse_x - Item[ActiveItem].Bitmap1->w, mouse_y);   // s
                  if (ItemType==3)
                    position_mouse(mouse_x - PlayerStartBitmap->w, mouse_y);   // s
                  break;
    }
    if (LevelData.xdec)   // Scrollar vnster
    {
      if (LevelData.xoff>0)
      {
        scare_mouse();  // Man mste skrmma bort musen innan man ska rita ngonting annars blir det vldigt cp
        LevelData.xoff--;            // Left
        blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10, LevelData.Length, LevelData.Height);
        unscare_mouse();  // Sen r det ju frsts bra att locka fram musen igen, s att vi kan beskda dess sknhet
      }
    }
    if (LevelData.ydec)   // Scrollar upp
    {
      if (LevelData.yoff>0)
      {
        scare_mouse();  // Man mste skrmma bort musen innan man ska rita ngonting annars blir det vldigt cp
        LevelData.yoff--;
        blit(LevelData.LevelBitmap, screen, LevelData.xoff,LevelData.yoff,0,10, LevelData.Length, LevelData.Height);
        unscare_mouse();  // Sen r det ju frsts bra att locka fram musen igen, s att vi kan beskda dess sknhet
      }
    }
    if ((LevelData.xinc) && ((key_shifts & 0x000F) == 0))  // Scrollar hger
    {
      if (LevelData.xoff<(LevelData.Length-320))
      {
        if (LevelData.xoff<(65535-320))
        {
          scare_mouse();
          LevelData.xoff++;            // Right
          blit(LevelData.LevelBitmap, screen, LevelData.xoff,LevelData.yoff,0,10, LevelData.Length, LevelData.Height);
          unscare_mouse();
        }
      }
    }
    if ((LevelData.yinc) && ((key_shifts & 0x000F) == 0))  // Scrollar hger
    {
      if (LevelData.yoff<(LevelData.Height-200))
      {
        if (LevelData.yoff<(65535-200))
        {
          scare_mouse();
          LevelData.yoff++;
          blit(LevelData.LevelBitmap, screen, LevelData.xoff,LevelData.yoff,0,10, LevelData.Length, LevelData.Height);
          unscare_mouse();
        }
      }
    }
    if ((LevelData.xinc) && ((key_shifts & 0x000F) == 2))  // Scrollar hger, och utkar bitmapens storlek om det skulle behvas
    {
      if (LevelData.xoff<(65535-320))
      {
        scare_mouse();
        LevelData.xoff++;            // Right
        if (320+LevelData.xoff>LevelData.Length)
        {
          TempBitmap=create_bitmap(320+LevelData.xoff, LevelData.Height);  // Skapa en temporr bitmap med samma storlek
          clear(TempBitmap);
          blit(LevelData.LevelBitmap, TempBitmap, 0,0,0,0,320+LevelData.xoff-1,LevelData.Height);  // Kopiera till den temporra bitmapen
          destroy_bitmap(LevelData.LevelBitmap);   // Ta bort den gamla
          LevelData.LevelBitmap=create_bitmap(320+LevelData.xoff,190);  // Skapa den gamla p nytt fast lite strre
          clear(LevelData.LevelBitmap);
          blit(TempBitmap, LevelData.LevelBitmap, 0,0,0,0,320+LevelData.xoff, LevelData.Height);  // Lgg tillbaka den innehllet i den nu lite strre bitmapen
          destroy_bitmap(TempBitmap);  // Ta bort tempbitmapen
          LevelData.Length=320+LevelData.xoff;  // Spara lngden i minnet
        }
        blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10, LevelData.Length, LevelData.Height);
        unscare_mouse();
      }
    }
    if ((LevelData.yinc) && ((key_shifts & 0x000F) == 2))  // Scrollar upp, och utkar bitmapens storlek om det skulle behvas
    {
      if (LevelData.yoff<(65535-200))
      {
        scare_mouse();
        LevelData.yoff++;            // Right
        if (200+LevelData.yoff>LevelData.Height)
        {
          TempBitmap=create_bitmap(LevelData.Length,200+LevelData.yoff);  // Skapa en temporr bitmap med samma storlek
          clear(TempBitmap);
          blit(LevelData.LevelBitmap, TempBitmap, 0,0,0,0,LevelData.Length, 200+LevelData.yoff-1);  // Kopiera till den temporra bitmapen
          destroy_bitmap(LevelData.LevelBitmap);   // Ta bort den gamla
          LevelData.LevelBitmap=create_bitmap(LevelData.Length,200+LevelData.yoff);  // Skapa den gamla p nytt fast lite strre
          clear(LevelData.LevelBitmap);
          blit(TempBitmap, LevelData.LevelBitmap, 0,0,0,0,LevelData.Length, 200+LevelData.yoff);  // Lgg tillbaka den innehllet i den nu lite strre bitmapen
          destroy_bitmap(TempBitmap);  // Ta bort tempbitmapen
          LevelData.Height=200+LevelData.yoff;  // Spara lngden i minnet
        }
        blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10, LevelData.Length, LevelData.Height);
        unscare_mouse();
      }
    }
    if ((mouse_x>30*8) && (mouse_x<((30*8)+4*8)) && (!draw))  // Koden hr nedan fixar s att man kan klicka med musen om olika delar av texten i vre delen p skrmen
    {
      if (mouse_b==1)
      {
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        textout(screen, font, "Exit", 30*8,0,240);
        blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        Delete=FALSE;
        done=TRUE;
        while (mouse_b & 1) {}
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        unscare_mouse();
      }
    }
    if ((mouse_x>23*8) && (mouse_x<((23*8)+6*8)) && (!draw))
    {
      if (mouse_b==1)
      {
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        textout(screen, font, "Delete", 23*8,0,240);
        blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        Delete=TRUE;
        while (mouse_b & 1) {}
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        unscare_mouse();
      }
    }                       // PlayerStart
    if ((mouse_x>20*8) && (mouse_x<((20*8)+2*8)) && (!draw))
    {
      if (mouse_b==1)
      {
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        textout(screen, font, "PS", 20*8,0,240);
        blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        ItemType=3;
        Delete=FALSE;
        while (mouse_b & 1) {}
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        unscare_mouse();
      }
    }                       // Texture <
    if ((mouse_x>2*8) && (mouse_x<((2*8)+8)) && (!draw))
    {
      if (mouse_b==1)
      {
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        textout(screen, font, "<", 2*8,0,240);
        blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        Delete=FALSE;
        ItemType=0;
        ActiveTexture--;
        if (ActiveTexture<0)
          ActiveTexture=BlockTextureCount-1;
        while (mouse_b & 1) {}
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        unscare_mouse();
      }
    }                       // Texture >
    if ((mouse_x>4*8) && (mouse_x<((4*8)+8)) && (!draw))
    {
      if (mouse_b==1)
      {
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        textout(screen, font, ">", 4*8,0,240);
        blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        Delete=FALSE;
        ItemType=0;
        ActiveTexture++;
        if (ActiveTexture==BlockTextureCount)
          ActiveTexture=0;
        while (mouse_b & 1) {}
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        unscare_mouse();
      }
    }                    // Texture -
    if ((mouse_x>3*8) && (mouse_x<((3*8)+8)) && (!draw))
    {
      if (mouse_b==1)
      {
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        textout(screen, font, "-", 3*8,0,240);
        Delete=FALSE;
        blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        ItemType=0;
        ActiveTexture=0;
        while (mouse_b & 1) {}
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        unscare_mouse();
      }
    }                    // Texture Text
    if ((mouse_x>0*8) && (mouse_x<((0*8)+8)) && (!draw))
    {
      if (mouse_b==1)
      {
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        textout(screen, font, "T", 0*8,0,240);
        Delete=FALSE;
        blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        ItemType=0;
        while (mouse_b & 1) {}
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        unscare_mouse();
      }
    }                    // Enemy <
    if ((mouse_x>9*8) && (mouse_x<((9*8)+8)) && (!draw))
    {
      if (mouse_b==1)
      {
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        textout(screen, font, "<", 9*8,0,240);
        blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        Delete=FALSE;
        ItemType=1;
        ActiveEnemy--;
        if (ActiveEnemy<0)
          ActiveEnemy=EnemyTextureCount-1;
        while (mouse_b & 1) {}
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        unscare_mouse();
      }
    }                       // Enemy >
    if ((mouse_x>11*8) && (mouse_x<((11*8)+8)) && (!draw))
    {
      if (mouse_b==1)
      {
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        textout(screen, font, ">", 11*8,0,240);
        blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        Delete=FALSE;
        ItemType=1;
        ActiveEnemy++;
        if (ActiveEnemy==EnemyTextureCount)
          ActiveEnemy=0;
        while (mouse_b & 1) {}
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        unscare_mouse();
      }
    }                        // Enemy -
    if ((mouse_x>10*8) && (mouse_x<((10*8)+8)) && (!draw))
    {
      if (mouse_b==1)
      {
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        textout(screen, font, "-", 10*8,0,240);
        Delete=FALSE;
        blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        ItemType=1;
        ActiveEnemy=0;
        while (mouse_b & 1) {}
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        unscare_mouse();
      }
    }                       // Enemy Text
    if ((mouse_x>7*8) && (mouse_x<((7*8)+8)) && (!draw))
    {
      if (mouse_b==1)
      {
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        textout(screen, font, "E", 7*8,0,240);
        Delete=FALSE;
        blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        ItemType=1;
        while (mouse_b & 1) {}
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        unscare_mouse();
      }
    }                        // Item <
    if ((mouse_x>16*8) && (mouse_x<((16*8)+8)) && (!draw))
    {
      if (mouse_b==1)
      {
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        textout(screen, font, "<", 16*8,0,240);
        ItemType=2;
        Delete=FALSE;
        blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        ActiveItem--;
        if (ActiveItem<0)
          ActiveItem=ItemTextureCount-1;
        while (mouse_b & 1) {}
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        unscare_mouse();
      }
    }                       // Item >
    if ((mouse_x>18*8) && (mouse_x<((18*8)+8)) && (!draw))
    {
      if (mouse_b==1)
      {
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        textout(screen, font, ">", 18*8,0,240);
        Delete=FALSE;
        blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        ItemType=2;
        ActiveItem++;
        if (ActiveItem==ItemTextureCount)
          ActiveItem=0;
        while (mouse_b & 1) {}
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        unscare_mouse();
      }
    }                        // Item -
    if ((mouse_x>17*8) && (mouse_x<((17*8)+8)) && (!draw))
    {
      if (mouse_b==1)
      {
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        textout(screen, font, "-", 17*8,0,240);
        Delete=FALSE;
        blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        ItemType=2;
        ActiveItem=0;
        while (mouse_b & 1) {}
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        unscare_mouse();
      }
    }                       // Item Text
    if ((mouse_x>14*8) && (mouse_x<((14*8)+8)) && (!draw))
    {
      if (mouse_b==1)
      {
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        textout(screen, font, "I", 14*8,0,240);
        Delete=FALSE;
        blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        ItemType=2;
        while (mouse_b & 1) {}
        scare_mouse();
        textout(screen, font, MENUTEXT, 0,0,250);
        unscare_mouse();
      }
    }
    if ((mouse_y<11) && (draw))  // Fixar s att den vanliga muspekaren syns nr man kommer till den vre delen av skrmen
    {
      set_mouse_sprite(NULL);
      draw=FALSE;
    }
    if ((mouse_y>10) && (!draw))  // Fixar tillbaka dom fina spritsen nr man kommer p ritytan
    {
      if (ItemType==0)
        set_mouse_sprite(Texture[ActiveTexture].Bitmap);  // Fixar till s att vi kan se en snygg (?) sprite istllet fr den hemska pilen :)
      if (ItemType==1)
        set_mouse_sprite(Enemy[ActiveEnemy].Bitmap1);
      if (ItemType==2)
        set_mouse_sprite(Item[ActiveItem].Bitmap1);
      if (ItemType==3)
        set_mouse_sprite(PlayerStartBitmap);
      if (Delete)
        set_mouse_sprite(NULL);
     draw=TRUE;
    }
    if ((mouse_y>10) && (Delete))
    {
      for (a=0;a<LevelData.BlockCount;a++)
      {
        if (((mouse_x+LevelData.xoff)>LevelData.BlockPos[a].x) && ((mouse_y-10+LevelData.yoff)>LevelData.BlockPos[a].y) && ((mouse_x+LevelData.xoff)<(LevelData.BlockPos[a].x+Texture[LevelData.BlockPos[a].ident].Bitmap->w)) && ((mouse_y-10+LevelData.yoff)<(LevelData.BlockPos[a].y+Texture[LevelData.BlockPos[a].ident].Bitmap->h)) && (LastIdent!=a))
        {
          LastIdent=a;
          DeleteType=0;
          scare_mouse();
          blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
          for (x=LevelData.BlockPos[a].x;x<(LevelData.BlockPos[a].x+Texture[LevelData.BlockPos[a].ident].Bitmap->w);x+=2)
          {
            for (y=LevelData.BlockPos[a].y;y<(LevelData.BlockPos[a].y+Texture[LevelData.BlockPos[a].ident].Bitmap->h);y+=2)
            {
              _putpixel(screen, x-LevelData.xoff, y+10-LevelData.yoff, 125);
            }
          }
          unscare_mouse();
          break;
        }
      }
      for (a=0;a<LevelData.EnemyCount;a++)
      {
        if (((mouse_x+LevelData.xoff)>LevelData.EnemyPos[a].x) && ((mouse_y-10+LevelData.yoff)>LevelData.EnemyPos[a].y) && ((mouse_x+LevelData.xoff)<(LevelData.EnemyPos[a].x+Enemy[LevelData.EnemyPos[a].ident].Bitmap1->w)) && ((mouse_y-10+LevelData.yoff)<(LevelData.EnemyPos[a].y+Enemy[LevelData.EnemyPos[a].ident].Bitmap1->h)) && (LastIdent!=a))
        {
          LastIdent=a;
          DeleteType=1;
          scare_mouse();
          blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
          for (x=LevelData.EnemyPos[a].x;x<(LevelData.EnemyPos[a].x+Enemy[LevelData.EnemyPos[a].ident].Bitmap1->w);x+=2)
          {
            for (y=LevelData.EnemyPos[a].y;y<(LevelData.EnemyPos[a].y+Enemy[LevelData.EnemyPos[a].ident].Bitmap1->h);y+=2)
            {
              _putpixel(screen, x-LevelData.xoff, y+10-LevelData.yoff, 125);
            }
          }
          unscare_mouse();
          break;
        }
      }
      for (a=0;a<LevelData.ItemCount;a++)
      {
        if (((mouse_x+LevelData.xoff)>LevelData.ItemPos[a].x) && ((mouse_y-10+LevelData.yoff)>LevelData.ItemPos[a].y) && ((mouse_x+LevelData.xoff)<(LevelData.ItemPos[a].x+Item[LevelData.ItemPos[a].ident].Bitmap1->w)) && ((mouse_y-10+LevelData.yoff)<(LevelData.ItemPos[a].y+Item[LevelData.ItemPos[a].ident].Bitmap1->h)) && (LastIdent!=a))
        {
          LastIdent=a;
          DeleteType=2;
          scare_mouse();
          blit(LevelData.LevelBitmap, screen, LevelData.xoff, LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
          for (x=LevelData.ItemPos[a].x;x<(LevelData.ItemPos[a].x+Item[LevelData.ItemPos[a].ident].Bitmap1->w);x+=2)
          {
            for (y=LevelData.ItemPos[a].y;y<(LevelData.ItemPos[a].y+Item[LevelData.ItemPos[a].ident].Bitmap1->h);y+=2)
            {
              _putpixel(screen, x-LevelData.xoff, y+10-LevelData.yoff, 125);
            }
          }
          unscare_mouse();
          break;
        }
      }
    }
    if ((Delete) &&  (mouse_b==1))
    {
      if (DeleteType==0)
      {
        for (a=LastIdent;a<LevelData.BlockCount-1;a++)
        {
          LevelData.BlockPos[a].x=LevelData.BlockPos[a+1].x;
          LevelData.BlockPos[a].y=LevelData.BlockPos[a+1].y;
          LevelData.BlockPos[a].ident=LevelData.BlockPos[a+1].ident;
        }
        LevelData.BlockCount--;
        TempPos=malloc(sizeof(struct TItemPos)*(LevelData.BlockCount+10));
        memcpy(TempPos, LevelData.BlockPos, sizeof(struct TItemPos)*LevelData.BlockCount);
        LevelData.BlockPos=realloc(LevelData.BlockPos, sizeof(struct TItemPos)*(LevelData.BlockCount+10));
        memcpy(LevelData.BlockPos, TempPos, sizeof(struct TItemPos)*LevelData.BlockCount);
        free(TempPos);
        scare_mouse();
        clear(LevelData.LevelBitmap);
        for (a=0;a<LevelData.BlockCount;a++)
        {
          masked_blit(Texture[LevelData.BlockPos[a].ident].Bitmap, LevelData.LevelBitmap,  0, 0, LevelData.BlockPos[a].x, LevelData.BlockPos[a].y, Texture[LevelData.BlockPos[a].ident].Width, Texture[LevelData.BlockPos[a].ident].Height);
        }
        for (a=0;a<LevelData.EnemyCount;a++)
        {
          masked_blit(Enemy[LevelData.EnemyPos[a].ident].Bitmap1, LevelData.LevelBitmap,  0, 0, LevelData.EnemyPos[a].x, LevelData.EnemyPos[a].y, Enemy[LevelData.EnemyPos[a].ident].Bitmap1->w, Enemy[LevelData.EnemyPos[a].ident].Bitmap1->h);
        }
        for (a=0;a<LevelData.ItemCount;a++)
        {
          masked_blit(Item[LevelData.ItemPos[a].ident].Bitmap1, LevelData.LevelBitmap,  0, 0, LevelData.ItemPos[a].x, LevelData.ItemPos[a].y, Item[LevelData.ItemPos[a].ident].Bitmap1->w, Item[LevelData.ItemPos[a].ident].Bitmap1->h);
        }
        masked_blit(PlayerStartBitmap, LevelData.LevelBitmap, 0,0, Player.StartX, Player.StartY, PlayerStartBitmap->w, PlayerStartBitmap->h);
        hline(screen, 0, 9, 320, 100);
        blit(LevelData.LevelBitmap, screen, LevelData.xoff,LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        DeleteType=1000;
      }
      if (DeleteType==1)
      {
        for (a=LastIdent;a<LevelData.EnemyCount-1;a++)
        {
          LevelData.EnemyPos[a].x=LevelData.EnemyPos[a+1].x;
          LevelData.EnemyPos[a].y=LevelData.EnemyPos[a+1].y;
          LevelData.EnemyPos[a].ident=LevelData.EnemyPos[a+1].ident;
        }
        LevelData.EnemyCount--;
        TempPos=malloc(sizeof(struct TItemPos)*(LevelData.EnemyCount+10));
        memcpy(TempPos, LevelData.EnemyPos, sizeof(struct TItemPos)*LevelData.EnemyCount);
        LevelData.EnemyPos=realloc(LevelData.EnemyPos, sizeof(struct TItemPos)*(LevelData.EnemyCount+10));
        memcpy(LevelData.EnemyPos, TempPos, sizeof(struct TItemPos)*LevelData.EnemyCount);
        free(TempPos);
        scare_mouse();
        clear(LevelData.LevelBitmap);
        for (a=0;a<LevelData.BlockCount;a++)
        {
          masked_blit(Texture[LevelData.BlockPos[a].ident].Bitmap, LevelData.LevelBitmap,  0, 0, LevelData.BlockPos[a].x, LevelData.BlockPos[a].y, Texture[LevelData.BlockPos[a].ident].Width, Texture[LevelData.BlockPos[a].ident].Height);
        }
        for (a=0;a<LevelData.EnemyCount;a++)
        {
          masked_blit(Enemy[LevelData.EnemyPos[a].ident].Bitmap1, LevelData.LevelBitmap,  0, 0, LevelData.EnemyPos[a].x, LevelData.EnemyPos[a].y, Enemy[LevelData.EnemyPos[a].ident].Bitmap1->w, Enemy[LevelData.EnemyPos[a].ident].Bitmap1->h);
        }
        for (a=0;a<LevelData.ItemCount;a++)
        {
          masked_blit(Item[LevelData.ItemPos[a].ident].Bitmap1, LevelData.LevelBitmap,  0, 0, LevelData.ItemPos[a].x, LevelData.ItemPos[a].y, Item[LevelData.ItemPos[a].ident].Bitmap1->w, Item[LevelData.ItemPos[a].ident].Bitmap1->h);
        }
        masked_blit(PlayerStartBitmap, LevelData.LevelBitmap, 0,0, Player.StartX, Player.StartY, PlayerStartBitmap->w, PlayerStartBitmap->h);
        hline(screen, 0, 9, 320, 100);
        blit(LevelData.LevelBitmap, screen, LevelData.xoff,LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        DeleteType=1000;
      }
      if (DeleteType==2)
      {
        for (a=LastIdent;a<LevelData.ItemCount-1;a++)
        {
          LevelData.ItemPos[a].x=LevelData.ItemPos[a+1].x;
          LevelData.ItemPos[a].y=LevelData.ItemPos[a+1].y;
          LevelData.ItemPos[a].ident=LevelData.ItemPos[a+1].ident;
        }
        LevelData.ItemCount--;
        TempPos=malloc(sizeof(struct TItemPos)*(LevelData.ItemCount+10));
        memcpy(TempPos, LevelData.ItemPos, sizeof(struct TItemPos)*LevelData.ItemCount);
        LevelData.ItemPos=realloc(LevelData.ItemPos, sizeof(struct TItemPos)*(LevelData.ItemCount+10));
        memcpy(LevelData.ItemPos, TempPos, sizeof(struct TItemPos)*LevelData.ItemCount);
        free(TempPos);
        scare_mouse();
        clear(LevelData.LevelBitmap);
        for (a=0;a<LevelData.BlockCount;a++)
        {
          masked_blit(Texture[LevelData.BlockPos[a].ident].Bitmap, LevelData.LevelBitmap,  0, 0, LevelData.BlockPos[a].x, LevelData.BlockPos[a].y, Texture[LevelData.BlockPos[a].ident].Width, Texture[LevelData.BlockPos[a].ident].Height);
        }
        for (a=0;a<LevelData.EnemyCount;a++)
        {
          masked_blit(Enemy[LevelData.EnemyPos[a].ident].Bitmap1, LevelData.LevelBitmap,  0, 0, LevelData.EnemyPos[a].x, LevelData.EnemyPos[a].y, Enemy[LevelData.EnemyPos[a].ident].Bitmap1->w, Enemy[LevelData.EnemyPos[a].ident].Bitmap1->h);
        }
        for (a=0;a<LevelData.ItemCount;a++)
        {
          masked_blit(Item[LevelData.ItemPos[a].ident].Bitmap1, LevelData.LevelBitmap,  0, 0, LevelData.ItemPos[a].x, LevelData.ItemPos[a].y, Item[LevelData.ItemPos[a].ident].Bitmap1->w, Item[LevelData.ItemPos[a].ident].Bitmap1->h);
        }
        masked_blit(PlayerStartBitmap, LevelData.LevelBitmap, 0,0, Player.StartX, Player.StartY, PlayerStartBitmap->w, PlayerStartBitmap->h);
        hline(screen, 0, 9, 320, 100);
        blit(LevelData.LevelBitmap, screen, LevelData.xoff,LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        DeleteType=1000;
      }
    }
    if ((mouse_b==1) && (draw) && (!Delete))  // Placerar en sprite p skrmen samt sparar den i minnet
    {
      if (ItemType==0)
      {
        scare_mouse();
        LevelData.BlockPos[LevelData.BlockCount].x=mouse_x-1+LevelData.xoff;  // Spara i minnet   -1 har jag fr att musens positioner tydligen inte riktigt stmmer med skrmkoordinaterna
        LevelData.BlockPos[LevelData.BlockCount].y=mouse_y-11+LevelData.yoff; // Minus 11 fr att ta bort den lilla kanten lngst  upp p skrmen som r 10 pixlar stor
        LevelData.BlockPos[LevelData.BlockCount].ident=ActiveTexture;
        LevelData.BlockPos[LevelData.BlockCount].Stop1x=0;
        LevelData.BlockPos[LevelData.BlockCount].Stop1y=0;
        LevelData.BlockPos[LevelData.BlockCount].Stop2x=0;
        LevelData.BlockPos[LevelData.BlockCount].Stop2y=0;
        LevelData.BlockCount++;
        TempPos=malloc(sizeof(struct TItemPos)*(LevelData.BlockCount+10));    // Allokerar minne fr saker
        memcpy(TempPos, LevelData.BlockPos, sizeof(struct TItemPos)*LevelData.BlockCount);
        LevelData.BlockPos=realloc(LevelData.BlockPos, sizeof(struct TItemPos)*(LevelData.BlockCount+10));
        memcpy(LevelData.BlockPos, TempPos, sizeof(struct TItemPos)*LevelData.BlockCount);
        free(TempPos);
        masked_blit(Texture[ActiveTexture].Bitmap, LevelData.LevelBitmap, 0,0,mouse_x-1+LevelData.xoff, mouse_y-11+LevelData.yoff, Texture[ActiveTexture].Width, Texture[ActiveTexture].Height);
        vsync();
        hline(screen, 0, 9, 320, 100);
        blit(LevelData.LevelBitmap, screen, LevelData.xoff,LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        while (mouse_b & 1) {}
      }
      if (ItemType==1)
      {
        scare_mouse();
        LevelData.EnemyPos[LevelData.EnemyCount].x=mouse_x-1+LevelData.xoff;
        LevelData.EnemyPos[LevelData.EnemyCount].y=mouse_y-11+LevelData.yoff;
        LevelData.EnemyPos[LevelData.EnemyCount].ident=ActiveEnemy;
        masked_blit(Enemy[ActiveEnemy].Bitmap1, LevelData.LevelBitmap, 0,0,mouse_x-1+LevelData.xoff, mouse_y-11+LevelData.yoff, Enemy[ActiveEnemy].Bitmap1->w, Enemy[ActiveEnemy].Bitmap1->h);
        vsync();
        hline(screen, 0, 9, 320, 100);
        blit(LevelData.LevelBitmap, screen, LevelData.xoff,LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        while (mouse_b & 1) {}
        set_mouse_sprite(EnemyStop1Bitmap);
        while (!mouse_b==1) {}
        LevelData.EnemyPos[LevelData.EnemyCount].Stop1x=mouse_x-1+LevelData.xoff;
        LevelData.EnemyPos[LevelData.EnemyCount].Stop1y=mouse_y-11+LevelData.yoff;
        while (mouse_b & 1) {}
        set_mouse_sprite(EnemyStop2Bitmap);
        while (!mouse_b==1) {}
        LevelData.EnemyPos[LevelData.EnemyCount].Stop2x=mouse_x-1+LevelData.xoff;
        LevelData.EnemyPos[LevelData.EnemyCount].Stop2y=mouse_y-11+LevelData.yoff;
        while (mouse_b & 1) {}
        set_mouse_sprite(Enemy[ActiveEnemy].Bitmap1);
        //textprintf(screen, font, 0,50,125,"[X1: %i] [X2: %i]", LevelData.EnemyPos[LevelData.EnemyCount].Stop1x, LevelData.EnemyPos[LevelData.EnemyCount].Stop2x);
        LevelData.EnemyCount++;
        TempPos=malloc(sizeof(struct TItemPos)*(LevelData.EnemyCount+10));    // Allokerar minne fr saker
        memcpy(TempPos, LevelData.EnemyPos, sizeof(struct TItemPos)*LevelData.EnemyCount);
        LevelData.EnemyPos=realloc(LevelData.EnemyPos, sizeof(struct TItemPos)*(LevelData.EnemyCount+10));
        memcpy(LevelData.EnemyPos, TempPos, sizeof(struct TItemPos)*LevelData.EnemyCount);
        free(TempPos);
        //textprintf(screen, font, 0,50+8,125,"[X1: %i] [X2: %i]", LevelData.EnemyPos[LevelData.EnemyCount-1].Stop1x, LevelData.EnemyPos[LevelData.EnemyCount-1].Stop2x);
      }
      if (ItemType==2)
      {
        scare_mouse();
        LevelData.ItemPos[LevelData.ItemCount].x=mouse_x-1+LevelData.xoff;
        LevelData.ItemPos[LevelData.ItemCount].y=mouse_y-11+LevelData.yoff;
        LevelData.ItemPos[LevelData.ItemCount].ident=ActiveItem;
        LevelData.ItemPos[LevelData.ItemCount].Stop1x=0;
        LevelData.ItemPos[LevelData.ItemCount].Stop1y=0;
        LevelData.ItemPos[LevelData.ItemCount].Stop2x=0;
        LevelData.ItemPos[LevelData.ItemCount].Stop2y=0;
        LevelData.ItemCount++;
        TempPos=malloc(sizeof(struct TItemPos)*(LevelData.ItemCount+10));    // Allokerar minne fr saker
        memcpy(TempPos, LevelData.ItemPos, sizeof(struct TItemPos)*LevelData.ItemCount);
        LevelData.ItemPos=realloc(LevelData.ItemPos, sizeof(struct TItemPos)*(LevelData.ItemCount+10));
        memcpy(LevelData.ItemPos, TempPos, sizeof(struct TItemPos)*LevelData.ItemCount);
        free(TempPos);
        masked_blit(Item[ActiveItem].Bitmap1, LevelData.LevelBitmap, 0,0,mouse_x-1+LevelData.xoff, mouse_y-11+LevelData.yoff, Item[ActiveItem].Bitmap1->w, Item[ActiveItem].Bitmap1->h);
        vsync();
        hline(screen, 0, 9, 320, 100);
        blit(LevelData.LevelBitmap, screen, LevelData.xoff,LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        //textprintf(screen, font, 0,20,100, "X %i Y %i   ", LevelData.ItemPos[LevelData.ItemCount-1].x, LevelData.ItemPos[LevelData.ItemCount-1].y);
        unscare_mouse();
        while (mouse_b & 1) {}
      }
      if ((ItemType==3))
      {
        scare_mouse();
        Player.x=mouse_x-1+LevelData.xoff;
        Player.y=mouse_y-11+LevelData.yoff;
        Player.StartX=Player.x;
        Player.StartY=Player.y;
        //masked_blit(PlayerStartBitmap, LevelData.LevelBitmap, 0,0,mouse_x-1+LevelData.xoff, mouse_y-11, PlayerStartBitmap->w, PlayerStartBitmap->h);
        //vsync();
        //hline(screen, 0, 9, 320, 100);
        //blit(LevelData.LevelBitmap, screen, LevelData.xoff,0,0,10,LevelData.Length,190);
        clear(LevelData.LevelBitmap);
        for (a=0;a<LevelData.BlockCount;a++)
        {
          masked_blit(Texture[LevelData.BlockPos[a].ident].Bitmap, LevelData.LevelBitmap,  0, 0, LevelData.BlockPos[a].x, LevelData.BlockPos[a].y, Texture[LevelData.BlockPos[a].ident].Width, Texture[LevelData.BlockPos[a].ident].Height);
        }
        for (a=0;a<LevelData.EnemyCount;a++)
        {
          masked_blit(Enemy[LevelData.EnemyPos[a].ident].Bitmap1, LevelData.LevelBitmap,  0, 0, LevelData.EnemyPos[a].x, LevelData.EnemyPos[a].y, Enemy[LevelData.EnemyPos[a].ident].Bitmap1->w, Enemy[LevelData.EnemyPos[a].ident].Bitmap1->h);
        }
        for (a=0;a<LevelData.ItemCount;a++)
        {
          masked_blit(Item[LevelData.ItemPos[a].ident].Bitmap1, LevelData.LevelBitmap,  0, 0, LevelData.ItemPos[a].x, LevelData.ItemPos[a].y, Item[LevelData.ItemPos[a].ident].Bitmap1->w, Item[LevelData.ItemPos[a].ident].Bitmap1->h);
        }
        masked_blit(PlayerStartBitmap, LevelData.LevelBitmap, 0,0, Player.StartX, Player.StartY, PlayerStartBitmap->w, PlayerStartBitmap->h);
        hline(screen, 0, 9, 320, 100);
        blit(LevelData.LevelBitmap, screen, LevelData.xoff,LevelData.yoff,0,10,LevelData.Length,LevelData.Height);
        unscare_mouse();
        while (mouse_b & 1) {}
      }
    }
    if ((mouse_b==2) && (draw) && (!Delete))  // Nsta textur  (Hgerknappen)
    {
      if (ItemType==0)
      {
        ActiveTexture++;
        if (ActiveTexture==BlockTextureCount)
          ActiveTexture=0;
        set_mouse_sprite(Texture[ActiveTexture].Bitmap);
      }
      if (ItemType==1)
      {
        ActiveEnemy++;
        if (ActiveEnemy==EnemyTextureCount)
          ActiveEnemy=0;
        set_mouse_sprite(Enemy[ActiveEnemy].Bitmap1);
      }
      if (ItemType==2)
      {
        ActiveItem++;
        if (ActiveItem==ItemTextureCount)
          ActiveItem=0;
        set_mouse_sprite(Item[ActiveItem].Bitmap1);
      }
      while (mouse_b & 2) {}
    }
    if ((mouse_b==4) && (draw) && (!Delete))  // Fregende textur (Mittenknappen)
    {
    if (ItemType==0)
      {
        ActiveTexture--;
        if (ActiveTexture==-1)
          ActiveTexture=BlockTextureCount-1;
        set_mouse_sprite(Texture[ActiveTexture].Bitmap);
      }
    if (ItemType==1)
      {
        ActiveEnemy--;
        if (ActiveEnemy==-1)
          ActiveEnemy=EnemyTextureCount-1;
        set_mouse_sprite(Enemy[ActiveEnemy].Bitmap1);
      }
    if (ItemType==2)
      {
        ActiveItem--;
        if (ActiveItem==-1)
          ActiveItem=ItemTextureCount-1;
        set_mouse_sprite(Item[ActiveItem].Bitmap1);
      }
      while (mouse_b & 4) {}
    }
  }
  //  textprintf(screen, font, 0, 12, 100, "%i", F);

  // Spara banan!

  F=fopen(filename, "w");
  fseek(F, 0, SEEK_SET);
/*  textprintf(screen, font, 0, 20, 100, "%i : %i", ferror(F), F);
  readkey();*/
  fputs("LGL100", F);
  fputs("Test Level 6", F);
  fseek(F, 26, SEEK_SET);
  fputc(0xAC, F);
  fputc(hi(LevelData.Length), F);
  fputc(lo(LevelData.Length), F);
  fputc(hi(LevelData.Height), F);
  fputc(lo(LevelData.Height), F);
  fputc(hi(LevelData.BlockCount), F);
  fputc(lo(LevelData.BlockCount), F);
  fputc(hi(LevelData.EnemyCount), F);
  fputc(lo(LevelData.EnemyCount), F);
  fputc(hi(LevelData.ItemCount), F);
  fputc(lo(LevelData.ItemCount), F);
  fputc(hi(Player.x), F);
  fputc(lo(Player.x), F);
  fputc(hi(Player.y), F);
  fputc(lo(Player.y), F);
  for (a=0;a<LevelData.BlockCount;a++)
  {
    fputc(LevelData.BlockPos[a].ident, F);
    fputc(hi(LevelData.BlockPos[a].x), F);
    fputc(lo(LevelData.BlockPos[a].x), F);
    fputc(hi(LevelData.BlockPos[a].y), F);
    fputc(lo(LevelData.BlockPos[a].y), F);
    fputc(hi(LevelData.BlockPos[a].Stop1x), F);
    fputc(lo(LevelData.BlockPos[a].Stop1x), F);
    fputc(hi(LevelData.BlockPos[a].Stop1y), F);
    fputc(lo(LevelData.BlockPos[a].Stop1y), F);
    fputc(hi(LevelData.BlockPos[a].Stop2x), F);
    fputc(lo(LevelData.BlockPos[a].Stop2x), F);
    fputc(hi(LevelData.BlockPos[a].Stop2y), F);
    fputc(lo(LevelData.BlockPos[a].Stop2y), F);
  }
  for (a=0;a<LevelData.EnemyCount;a++)
  {
    fputc(LevelData.EnemyPos[a].ident, F);
    fputc(hi(LevelData.EnemyPos[a].x), F);
    fputc(lo(LevelData.EnemyPos[a].x), F);
    fputc(hi(LevelData.EnemyPos[a].y), F);
    fputc(lo(LevelData.EnemyPos[a].y), F);
    fputc(hi(LevelData.EnemyPos[a].Stop1x), F);
    fputc(lo(LevelData.EnemyPos[a].Stop1x), F);
    fputc(hi(LevelData.EnemyPos[a].Stop1y), F);
    fputc(lo(LevelData.EnemyPos[a].Stop1y), F);
    fputc(hi(LevelData.EnemyPos[a].Stop2x), F);
    fputc(lo(LevelData.EnemyPos[a].Stop2x), F);
    fputc(hi(LevelData.EnemyPos[a].Stop2y), F);
    fputc(lo(LevelData.EnemyPos[a].Stop2y), F);
  }
  for (a=0;a<LevelData.ItemCount;a++)
  {
    fputc(LevelData.ItemPos[a].ident, F);
    fputc(hi(LevelData.ItemPos[a].x), F);
    fputc(lo(LevelData.ItemPos[a].x), F);
    fputc(hi(LevelData.ItemPos[a].y), F);
    fputc(lo(LevelData.ItemPos[a].y), F);
    fputc(hi(LevelData.ItemPos[a].Stop1x), F);
    fputc(lo(LevelData.ItemPos[a].Stop1x), F);
    fputc(hi(LevelData.ItemPos[a].Stop1y), F);
    fputc(lo(LevelData.ItemPos[a].Stop1y), F);
    fputc(hi(LevelData.ItemPos[a].Stop2x), F);
    fputc(lo(LevelData.ItemPos[a].Stop2x), F);
    fputc(hi(LevelData.ItemPos[a].Stop2y), F);
    fputc(lo(LevelData.ItemPos[a].Stop2y), F);
  }
  fclose(F);
  //save_pcx("Levelbmp1.pcx" ,LevelData.LevelBitmap, Texture[0].Pal);
  return 0;
}


int load_textures()
{
  typedef struct TTextureFilename
  {
    char *a;
    char *b;
  } TTextureFilename;
  int j;
  TTextureFilename TextureFilename[TEXTURECOUNT+100];
  char *PlayerTextureFilename;
  Dat=load_datafile("pfont.dat");
  Pfont=(FONT *) Dat[0].dat;
  TextureFilename[0].a="Block1.pcx";
  TextureFilename[1].a="Block2.pcx";
  TextureFilename[2].a="Block3.pcx";
  TextureFilename[3].a="Block4.pcx";
  TextureFilename[4].a="Block5.pcx";
  TextureFilename[5].a="Block6.pcx";
  TextureFilename[6].a="Topp1.pcx";
  TextureFilename[7].a="Pipe1.pcx";
  TextureFilename[8].a="Block7.pcx";
  TextureFilename[9].a="Block8.pcx";
  TextureFilename[10].a="Block9.pcx";
  TextureFilename[11].a="Block10.pcx";
  TextureFilename[12].a="Block11.pcx";
  for (j=0;j<TEXTURECOUNT;j++)
  {
    Texture[j].Bitmap=load_bitmap(TextureFilename[j].a, Texture[j].Pal);
    Texture[j].Width=Texture[j].Bitmap->w;
    Texture[j].Height=Texture[j].Bitmap->h;
  }
  PlayerTextureFilename="Player1.pcx";
  Player.Bitmap1=load_bitmap(PlayerTextureFilename, Player.Pal);
  PlayerTextureFilename="Player2.pcx";
  Player.Bitmap2=load_bitmap(PlayerTextureFilename, Player.Pal);
  PlayerTextureFilename="Player3.pcx";
  Player.Bitmap3=load_bitmap(PlayerTextureFilename, Player.Pal);
  PlayerTextureFilename="Player4.pcx";
  Player.Bitmap4=load_bitmap(PlayerTextureFilename, Player.Pal);
  PlayerTextureFilename="Player5.pcx";
  Player.Bitmap5=load_bitmap(PlayerTextureFilename, Player.Pal);
  PlayerTextureFilename="Player6.pcx";
  Player.Bitmap6=load_bitmap(PlayerTextureFilename, Player.Pal);
  TextureFilename[0].a="Enemy1_1.pcx";
  TextureFilename[0].b="Enemy1_2.pcx";
  TextureFilename[1].a="Enemy2_1.pcx";
  TextureFilename[1].b="Enemy2_2.pcx";
  TextureFilename[2].a="Enemy3_1.pcx";
  TextureFilename[2].b="Enemy3_2.pcx";
  TextureFilename[3].a="Enemy4_1.pcx";
  TextureFilename[3].b="Enemy4_2.pcx";
  TextureFilename[4].a="Enemy5_1.pcx";
  TextureFilename[4].b="Enemy5_2.pcx";
  TextureFilename[5].a="Enemy6_1.pcx";
  TextureFilename[5].b="Enemy6_2.pcx";
  TextureFilename[6].a="Enemy7_1.pcx";
  TextureFilename[6].b="Enemy7_2.pcx";
  for (j=0;j<ENEMYCOUNT;j++)
  {
    Enemy[j].Bitmap1=load_bitmap(TextureFilename[j].a, Enemy[j].Pal);
    Enemy[j].Bitmap2=load_bitmap(TextureFilename[j].b, Enemy[j].Pal);
  }
  TextureFilename[0].a="Item1_1.pcx";
  TextureFilename[0].b="Item1_2.pcx";
  TextureFilename[1].a="Item2_1.pcx";
  TextureFilename[1].b="Item2_2.pcx";
  TextureFilename[2].a="Item3_1.pcx";
  TextureFilename[2].b="Item3_2.pcx";
  for (j=0;j<ITEMCOUNT;j++)
  {
    Item[j].Bitmap1=load_bitmap(TextureFilename[j].a, Item[j].Pal);
    Item[j].Bitmap2=load_bitmap(TextureFilename[j].b, Item[j].Pal);
  }
  TextureFilename[0].a="Backgr1.pcx";
  LevelData.Background=load_bitmap(TextureFilename[0].a, LevelData.Pal);
  if ((!NOMUSIC) && (!Design))
  {
    if ((SndSample[0].Sample=MIDASloadWaveSample("Snd1.wav", MIDAS_LOOP_NO))==NULL)
      MIDASerror();
    if ((SndSample[1].Sample=MIDASloadWaveSample("Snd2.wav", MIDAS_LOOP_NO))==NULL)
      MIDASerror();
    if ((SndSample[2].Sample=MIDASloadWaveSample("Snd3.wav", MIDAS_LOOP_NO))==NULL)
      MIDASerror();
    if ((SndSample[3].Sample=MIDASloadWaveSample("Snd4.wav", MIDAS_LOOP_NO))==NULL)
      MIDASerror();
  }
  return 0;
}

/*
int load_textures()
{
  struct TTextureFilename
  {
    char *a;
    char *b;
  } TTextureFilename;
  struct TTextureFilename *TextureFilename;
  char *PlayerTextureFilename;
  int j;
  Datafile=load_datafile("lggame1.dat");
  (short) BlockTextureCount=Datafile[BLOCKCOUNT_].dat;
  (short) EnemyTextureCount=Datafile[ENEMYCOUNT_].dat;
  (short) ItemTextureCount=Datafile[ITEMCOUNT_].dat;
  (short) LevelCount=Datafile[LEVELCOUNT_].dat;
  Texture=malloc(sizeof(struct TTexture)*(BlockTextureCount+1));
  memset(Texture, 0, BlockTextureCount+1);
  Enemy=malloc(sizeof(struct TEnemyInfo)*(EnemyTextureCount+1));
  memset(Enemy, 0, EnemyTextureCount+1);
  Item=malloc(sizeof(struct TItemInfo)*(ItemTextureCount+1));
  memset(Item, 0, ItemTextureCount+1);
  for (j=0;j<BlockTextureCount;j++)
  {
    Texture[j].Bitmap=Datafile[Block1_+j].dat;
    Texture[j].Width=Texture[j].Bitmap->w;
    Texture[j].Height=Texture[j].Bitmap->h;
  }
  for (j=0;j<EnemyTextureCount;j+=2)
  {
    Enemy[j].Bitmap1=Datafile[Enemy1_1_+j].dat;
    Enemy[j].Bitmap2=Datafile[Enemy1_1_+j+1].dat;
  }
  for (j=0;j<ItemTextureCount;j+=2)
  {
    Item[j].Bitmap1=Datafile[Item1_1_+j].dat;
    Item[j].Bitmap2=Datafile[Item1_1_+j+1].dat;
  }
//  PlayerTextureFilename="Player1.pcx";
  Player.Bitmap1=Datafile[Player1_].dat;
//  PlayerTextureFilename="Player2.pcx";
  Player.Bitmap2=Datafile[Player2_].dat;
//  PlayerTextureFilename="Player3.pcx";
  Player.Bitmap3=Datafile[Player3_].dat;
//  PlayerTextureFilename="Player4.pcx";
  Player.Bitmap4=Datafile[Player4_].dat;
  Player.Bitmap5=Datafile[Player5_].dat;
  Player.Bitmap6=Datafile[Player6_].dat;
  TextureFilename[0].a="Enemy1_1.pcx";
  TextureFilename[0].b="Enemy1_2.pcx";
  TextureFilename[1].a="Enemy2_1.pcx";
  TextureFilename[1].b="Enemy2_2.pcx";
  TextureFilename[2].a="Enemy3_1.pcx";
  TextureFilename[2].b="Enemy3_2.pcx";
  TextureFilename[3].a="Enemy4_1.pcx";
  TextureFilename[3].b="Enemy4_2.pcx";
  TextureFilename[4].a="Enemy5_1.pcx";
  TextureFilename[4].b="Enemy5_2.pcx";
  TextureFilename[5].a="Enemy6_1.pcx";
  TextureFilename[5].b="Enemy6_2.pcx";
  TextureFilename[6].a="Enemy7_1.pcx";
  TextureFilename[6].b="Enemy7_2.pcx";
  for (j=0;j<EnemyTextureCount;j++)
  {
    Enemy[j].Bitmap1=load_bitmap(TextureFilename[j].a, Enemy[j].Pal);
    Enemy[j].Bitmap2=load_bitmap(TextureFilename[j].b, Enemy[j].Pal);
  }
  TextureFilename[0].a="Item1_1.pcx";
  TextureFilename[0].b="Item1_2.pcx";
  TextureFilename[1].a="Item2_1.pcx";
  TextureFilename[1].b="Item2_2.pcx";
  TextureFilename[2].a="Item3_1.pcx";
  TextureFilename[2].b="Item3_2.pcx";
  for (j=0;j<ItemTextureCount;j++)
  {
    Item[j].Bitmap1=load_bitmap(TextureFilename[j].a, Item[j].Pal);
    Item[j].Bitmap2=load_bitmap(TextureFilename[j].b, Item[j].Pal);
  }
  TextureFilename[0].a="Backgr1.pcx";
  LevelData.Background=Datafile[Backgr1_].dat;
  if ((!NOMUSIC) && (!Design))
  {
    if ((SndSample[0].Sample=MIDASloadWaveSample("Snd1.wav", MIDAS_LOOP_NO))==NULL)
      MIDASerror();
    if ((SndSample[1].Sample=MIDASloadWaveSample("Snd2.wav", MIDAS_LOOP_NO))==NULL)
      MIDASerror();
    if ((SndSample[2].Sample=MIDASloadWaveSample("Snd3.wav", MIDAS_LOOP_NO))==NULL)
      MIDASerror();
    if ((SndSample[3].Sample=MIDASloadWaveSample("Snd4.wav", MIDAS_LOOP_NO))==NULL)
      MIDASerror();
  }
  return 0;
} */

int remove_textures()
{
  int a;
  for (a=0;a<BlockTextureCount;a++)
  {
    if (Texture[a].Bitmap!=NULL)
      destroy_bitmap(Texture[a].Bitmap);
    Texture[a].Width=0;
    Texture[a].Height=0;
  }
  destroy_bitmap(Player.Bitmap1);
  destroy_bitmap(Player.Bitmap2);
  destroy_bitmap(Player.Bitmap3);
  destroy_bitmap(Player.Bitmap4);
  for (a=0;a<EnemyTextureCount;a++)
  {
    if (Enemy[a].Bitmap1!=NULL)
      destroy_bitmap(Enemy[a].Bitmap1);
    if (Enemy[a].Bitmap2!=NULL)
      destroy_bitmap(Enemy[a].Bitmap2);
  }
  for (a=0;a<ItemTextureCount;a++)
  {
    if (Item[a].Bitmap1!=NULL)
      destroy_bitmap(Item[a].Bitmap1);
    if (Enemy[a].Bitmap2!=NULL)
      destroy_bitmap(Item[a].Bitmap2);
  }
  destroy_bitmap(LevelData.Background);
  if ((!NOMUSIC) && (!Design))
  {
    MIDASfreeSample(SndSample[0].Sample);
    MIDASfreeSample(SndSample[1].Sample);
    MIDASfreeSample(SndSample[2].Sample);
    MIDASfreeSample(SndSample[3].Sample);
  }
  return 0;
}

void WaitRefr()
{
  Refr=TRUE;
}


int main(int argc, char *argv[])
{
  int done=FALSE;
  int i, j;
  clrscr();
  if (strcmp(argv[1], "create")==0)
    Design=TRUE;
  else
    Design=FALSE;
  gfxmode=GFX_TEXT;
  allegro_init();
  if ((!Design) || (!NOMUSIC))
  {
    MIDASstartup();
    MIDASdetectSoundCard();
    if (!MIDASinit())
      MIDASerror();
    if (!MIDASopenChannels(4+4+1))
      MIDASerror();
    if (!NOMUSIC)
      if ((testmod=MIDASloadModule("testmod.mod"))==0)
        MIDASerror();
    if (!NOSYNC)
      MIDASsetTimerCallbacks(GAMESPEED , TRUE, &WaitRefr, NULL, NULL);
    if (!MIDASallocAutoEffectChannels(4))
      MIDASerror();
  }
  install_keyboard();
  keyboard_lowlevel_callback=&KeyRelease;  // Fixa s att KeyRelease() krs vid varje keyboard interupt
  if (Design)
    install_timer();
  mouseen=TRUE;
  if (Design)
    install_mouse();
  joyen=TRUE;
  if (joyen)
    install_joystick(JOY_TYPE_AUTODETECT);

  printf("Legion Game 1\n---------------------------\n\n");
  printf("e, Upp   - Jump\nf, Right   - Right\ns, Left   - Left\nEsc - Quit\n\n");

  clear_keybuf();
  gKey=0;
  load_textures();
/*  gKey=0;
  while (gKey!=283)
  {
    gKey=0;
    get_input();
    switch(lo(gKey))
    {
      case 49: if ((SndSample[0].Handle=MIDASplaySample(SndSample[0].Sample, MIDAS_CHANNEL_AUTO, 0, SAMPFREQ, 64, MIDAS_PAN_MIDDLE))==0)
                 MIDASerror();
               printf("1");
               break;
      case 50: if ((SndSample[1].Handle=MIDASplaySample(SndSample[1].Sample, MIDAS_CHANNEL_AUTO, 0, SAMPFREQ, 64, MIDAS_PAN_MIDDLE))==0)
                 MIDASerror();
               printf("2");
               break;
      case 51: if ((SndSample[2].Handle=MIDASplaySample(SndSample[2].Sample, MIDAS_CHANNEL_AUTO, 0, SAMPFREQ, 64, MIDAS_PAN_MIDDLE))==0)
                 MIDASerror();
               printf("3");
               break;
      case 52: if ((SndSample[3].Handle=MIDASplaySample(SndSample[3].Sample, MIDAS_CHANNEL_AUTO, 0, SAMPFREQ, 64, MIDAS_PAN_MIDDLE))==0)
                 MIDASerror();
               printf("4");
               break;
    }
  }*/
if (Design)
{
/*  if (strcmp(argv[2],"")==0)
    argv[1]="level1.lev";*/
  if (argc<2)
    argv[1]="level1.lev";
  printf("\n[Starting LG Game 1!]\n  - Switching to graphics mode... Press [Enter]\n");
  readkey();
  if (set_gfx_mode(GFX_VGA, 320, 200, 0, 0)<0)
    equit("Setting VGA graphics mode (320*200*256c)!");
  //printf(" OK!\n");
  gfxmode=GFX_VGA;
  design_new_level(argv[2]);
}
else
{
 /* if (strcmp(argv[1],"")==0)
    argv[1]="level1.lev";*/
  if (argc<2)
    argv[1]="level1.lev";
  //Player.x=0;
  //Player.y=10;
  load_level(argv[1]);
  printf("\n[Starting LG Game 1!]\n  - Switching to graphics mode... Press [Enter]\n");
  readkey();
  if (set_gfx_mode(GFX_VGA, 320, 200, 0, 0)<0)
    equit("Setting VGA graphics mode (320*200*256c)!");
  //printf(" OK!\n");
  gfxmode=GFX_VGA;

  Vir1=create_bitmap(320, 200);
  clear(Vir1);
  //save_pcx("Levelbmp.pcx" ,LevelData.LevelBitmap, Texture[0].Pal);
  done=FALSE;
/*  Player.x=80;
  Player.y=10; */
  Player.xdec=Player.xinc=FALSE;
  Player.fall=FALSE;
  Player.Score=0;
  Player.Dir=0;
  Player.Health=3;
  Player.Blink=FALSE;
  Player.BlinkCount=0;
//  Enemy[0].x=50;
//  Enemy[0].y=168-18;

/*  Enemy[0].x=50;
  Enemy[0].y=20;
  Enemy[0].Dir=0;
  Enemy[0].xdec=TRUE;
  Enemy[0].xinc=FALSE;*/
  for (i=0;i<LevelData.EnemyCount;i++)
  {
    LevelData.EnemyPos[i].Dir=0;
    LevelData.EnemyPos[i].xdec=TRUE;
    LevelData.EnemyPos[i].xinc=FALSE;
  }
  LevelData.xoff=0;
  set_palette(Texture[0].Pal);

  if ((!Design) && (!NOMUSIC))
  {
    if ((playHandle=MIDASplayModule(testmod, TRUE))==0)
      MIDASerror();
  }
  //readkey();
  while (done==FALSE)
  {
    gKey=0;
    get_input();
    switch(gKey)
    {
      case 283:    done=TRUE;
                   break;
      case 12386:  LevelData.yoff++;
                   break;
    }
/*    if //(joy[0].stick[0].axis[0].pos>10)
           (joy[0].stick[0].axis[0].d2)
    {
      Player.xincj=TRUE;
      Player.xdecj=FALSE;
      Player.Dir=0;
    }
    if //(joy[0].stick[0].axis[0].pos<-10)
         (joy[0].stick[0].axis[0].d1)
    {
      Player.xdecj=TRUE;
      Player.xincj=FALSE;
      Player.Dir=1;
    }
    if //((joy[0].stick[0].axis[0].pos>-10) && (joy[0].stick[0].axis[0].pos<10))
    ((!joy[0].stick[0].axis[0].d1) && (!joy[0].stick[0].axis[0].d2))
    {
      Player.xdecj=FALSE;
      Player.xincj=FALSE;
    }
    if //((joy[0].stick[0].axis[1].pos<-10) && (!Player.jump) && (!Player.fall))
         ((joy[0].button[0].b) && (!Player.jump) && (!Player.fall))
    {
      Player.jump=TRUE;
      Player.jumpx=Player.x;
      Player.jumpy=Player.y;
      JumpPathNum=0;
    }*/
    update_level();
    update_items();
    update_enemies();
    update_player();
    //vsync();
    if (!NOSYNC)
      while (!Refr) {}
    blit(Vir1, screen, 0,0,0,0, 320,200);
    Refr=FALSE;
  }
  //clear(screen);
}
  if ((!Design))
  {
    if (!NOMUSIC)
      MIDASstopModule(playHandle);
    if (!NOMUSIC)
      MIDASfreeModule(testmod);
    MIDASclose();
  }
  remove_textures();
  if (set_gfx_mode(GFX_TEXT, 640, 480, 0, 0)<0)
    equit("Setting TEXT mode!");
  printf("Back to DOS!\n");
  if (joyen)
     remove_joystick();
  if (Design)
    remove_mouse();
  if (Design)
    remove_timer();
  remove_keyboard();
  allegro_exit();
  return 0;
}
